var expirationTime = '';
var couponForm = [{}];//优惠券组提交的参数
var counponCodes = [];//优惠券组选中的code
var counponList = [[]];//优惠券列表组
var nowTime = parseInt(new Date().getTime() / 1000);
var payUrl = commonJSCaller.getQuery();
var packages = [];
var couponSceneCode = '';
var supportPay = false;
var financeInvoker = {
    /**
     *
     * @param {*}
     */
    init: function () {
        this.bindEvt();
        this.getDetail();
        this.getApartmentSurportPay();
    },
    getApartmentSurportPay: function () {
        var name = "getApartmentAppOpen";
        var param = {
            apartment_id: commonJSCaller.getQuery().apartment_id
        };
        var _this = this;
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "client2",
            param: param,
            calSuc: function (json) {
                if (json.data == 0) {
                    //没有开通线上支付
                    supportPay = false;
                } else {
                    supportPay = true;
                }
            },
            calFail: function (error) {
                alert(error.message || '获取门店是否开通线上支付失败，请联系管家！')
            }
        }
        LeHttp.send(options)
    },
    getTotalCouponMoneyByCode: function (index) {
        var mount = [];
        var coupons = [];
        if (counponCodes[index]) {
            counponCodes[index].split(',').forEach(function (el, i) {
                counponList[index].forEach(function (c) {
                    if (c.couponCode == el) {
                        coupons.push(c)
                    }
                });
            });
        }
        coupons.forEach(function (el) {
            mount.push(financeInvoker.convertCouponAmount([el], index))
        });
        return mount.join(',');
    },
    getAllCoupon: function (index) {
        var arr = financeInvoker.getTotalCouponMoneyByCode(index);
        var all = 0;
        arr.split(',').forEach(function (el) {
            all = commonJSCaller.FloatAdd(all, Number(el));
        });
        return all
    },
    bindEvt: function () {
        //展示金额详细
        $(document).on('click', '.show_detail', function () {
            var cur = $(this);
            $(this).find('.iconfont').toggleClass('icon-xiangshangjiantou').toggleClass('icon-xiangxiajiantou');
            if (cur.hasClass("active")) {
                cur.removeClass("active");
                cur.next().slideUp(200);
            } else {
                cur.addClass("active");
                cur.next().slideDown(200);
            }
        });
        //点击优惠券
        $(document).on('click', '.clickCoupon', function () {
            var index = Number($(this).parents('.finance-content').index());
            if ($('.goPay').eq(index).hasClass('disabled')) {
                //已支付的
                return false;
            }
            if (counponList[index].length == 0) return;
            var f = JSON.parse(JSON.stringify(couponForm[index]));
            f.selected = counponCodes[index] || '';
            commonJSCaller.jumpClientApp('CouponList', f, function (res) {
                //var res = [{couponCode: "1552899165431YQ7Zcoupon", discountMoney: 100}];
                console.log(res);
                var codes = [], couponAmount = 0;
                var allP = $('.goPay').eq(index).data('nopayment');
                couponAmount = financeInvoker.convertCouponAmount(res, index);
                res.forEach(function (el, i) {
                    codes.push(el.couponCode);
                });
                counponCodes[index] = codes.join(',');

                if (codes.length == 0) {
                    $('.has_coupon').eq(index).html(counponList[index].length + '张优惠券可用').removeClass('none').removeClass('c-red');
                    $(".no_coupon").eq(index).addClass("none");
                    $('.pay-total').eq(index).html(allP);
                    return false;
                }
                $('.has_coupon').eq(index).removeClass('none').addClass('c-red').html('<span>- ￥' + couponAmount + '</span><i class="icon-right"></i>');
                $('.pay-total').eq(index).html(commonJSCaller.FloatSub(Number(allP), Number(couponAmount)));
            });
        });

        //支付
        $(document).on('click', '.finance-btn', function () {
            if ($(this).hasClass('disabled')) return;
            var cur = $(this), text = cur.text();
            btnJSCaller.setBtnLoading(cur);
            setTimeout(function () {
                btnJSCaller.resetBtnLoading(cur, text);
            }, 1600);
            var index = Number($(this).parents('.finance-content').index());
            var noPayment = $(this).data('nopayment');
            var isMonths = $(this).data('month');
            var amount = $(this).data('amount');
            var subjectCode = $(this).data('subjectid');
            var serviceCode = commonJSCaller.getQuery().serviceCode;
            var billtype = $(this).data('billtype');
            noPayment = Number(noPayment);
            // if (commonJSCaller.isNeedSepPrice(commonJSCaller.getQuery().apartment_id)) {
            //     //需要判断分次
            //     if (isMonths != 1 && noPayment >= 1500 && (serviceCode == 'rent' || serviceCode == 'renew')) {
            //         //季付跳转分次
            //         var params = {
            //             payMoney: commonJSCaller.FloatSub(noPayment, financeInvoker.getAllCoupon(index)),
            //             amount: amount,
            //             subjectInfoId: subjectCode,
            //             contractBillId: payUrl.contractBillId,
            //             contractId: commonJSCaller.getQuery().contractId,
            //             serviceCode: payUrl.serviceCode,
            //             originServiceCode: commonJSCaller.getQuery().serviceCode,
            //             couponsCodes: counponCodes[index] || '',
            //             counponAmount: financeInvoker.getTotalCouponMoneyByCode(index),
            //             baseBillType: billtype,
            //         };
            //         if (params.couponsCodes) {
            //             params.counponSubjectId = [];
            //             params.discountAmount = [];

            //             counponList[index].forEach(function (el) {
            //                 params.couponsCodes.split(',').forEach(function (o) {
            //                     if (o == el.couponCode) {
            //                         params.counponSubjectId.push(el.subjectNumber)
            //                         params.discountAmount.push(el.discountMoney)
            //                     }
            //                 })
            //             })

            //             params.counponSubjectId = params.counponSubjectId.join(',');
            //             params.discountAmount = params.discountAmount.join(',');
            //         }
            //         if (commonJSCaller.getQuery().fromlist) {
            //             params.fromlist = commonJSCaller.getQuery().fromlist;
            //         }
            //         if (commonJSCaller.getQuery().fromh5) {
            //             params.fromh5 = 1;
            //         }
            //         var url = "/order_detail.html";
            //         url = commonJSCaller.setQuery(url, params);
            //         commonJSCaller.jumpToWap(url);
            //         return false;
            //     }
            // }

            //调起支付
            var param = {
                couponsCodes: counponCodes[index] || '',
                contractBillId: payUrl.contractBillId,
                subjectInfoId: subjectCode,
                serviceCode: payUrl.serviceCode,
                counponList: counponList[index],
                baseBillType: billtype,
                counponAmount: financeInvoker.getTotalCouponMoneyByCode(index)
            };

            if (param.couponsCodes) {
                param.counponSubjectId = [];
                param.discountAmount = [];

                counponList[index].forEach(function (el) {
                    param.couponsCodes.split(',').forEach(function (o) {
                        if (o == el.couponCode) {
                            param.counponSubjectId.push(el.subjectNumber)
                            param.discountAmount.push(el.discountMoney)
                        }
                    })
                })

                param.counponSubjectId = param.counponSubjectId.join(',');
                param.discountAmount = param.discountAmount.join(',');
            }
            payInvoker.payContractBill(param, function (json) {
                if (json.data.status == 1) {
                    commonJSCaller.jumpClientApp('Cashier', { payURL: json.data.url, clearRouteList: 1 }, function () {
                        commonJSCaller.paySuccessRoute({ contract_id: commonJSCaller.getQuery().contractId }, commonJSCaller.getQuery().serviceCode, commonJSCaller.getQuery().fromlist, commonJSCaller.getQuery().fromh5);
                    });
                } else {
                    //订单失效点击支付，提示订单已失效，从哪里来跳转那里去
                    alert(json.data.message || '账单支付失败');
                }
            });

        });
    },
    convertCouponAmount: function (coupons, index) {
        var suj = {};
        coupons.forEach(function (el, i) {
            if (!suj[el.subjectNumber]) {
                suj[el.subjectNumber] = {
                    amount: 0,
                    name: ''
                };
            }
            ;
            suj[el.subjectNumber].amount = commonJSCaller.FloatAdd(suj[el.subjectNumber].amount, Number(el.discountMoney))
            suj[el.subjectNumber].name = el.subjectName;
        });

        //判断科目费用是否小于优惠券费用，小于则优惠券 == 科目费用
        for (var key in suj) {
            packages[index].list.forEach(function (el) {
                if (el.subjectCode == key && el.amount < suj[key].amount) {
                    suj[key].amount = el.amount
                }
            });
        }

        var total = 0;
        for (var key in suj) {
            total = commonJSCaller.FloatAdd(total, Number(suj[key].amount))
        }

        return total;
    },
    /**
     * @desc 获取可用优惠
     */
    getCouponList: function (data, index) {
        var subject = data.list;
        var month = commonJSCaller.getQuery().contractCycle;
        var c = {}, subjectList = [];
        $.each(subject, function (i, o) {
            c[o.subjectCode.toString()] = o.amount;
            subjectList.push({
                subjectId: o.subjectCode,
                count: o.count,//笔数
                money: o.amount
            })
        });
        var para = {
            apartmentId: commonJSCaller.getQuery().apartment_id,
            useChannelCode: "lefull-tenant-app",
            sceneCode: couponSceneCode,
            subjectNumberAndMoneyJsonStr: JSON.stringify(c),
            contractCycle: month
        };

        //临时存储
        var storeForm = JSON.parse(JSON.stringify(para));
        storeForm.subjectList = subjectList
        couponForm[index] = storeForm;

        var options = {
            name: "get_coupon",
            apiList: financeAPI['apiList'],
            serviceName: "marketing",
            param: para,
            datatype: "json",
            calSuc: function (json) {
                //   json = {data: [{list: [{couponCode: "1547431965940297Gcoupon", discountMoney: 200}]}]};
                var cous = [];
                if (json.data.length > 0 && data.noPayment != 0) {
                    json.data.forEach(function (el, i) {
                        el.list.forEach(function (l) {
                            cous.push(l);
                        })
                    });
                    $('.has_coupon').eq(index).removeClass('none').find('span').html(cous.length + '张优惠券可用');
                    $(".no_coupon").eq(index).addClass("none");
                    counponList[index] = cous;
                    if (index == 0) {
                        financeInvoker.initCoupon(index);
                    }
                } else {
                    $('.has_coupon').eq(index).addClass('none');
                    counponList[index] = [];
                    $(".no_coupon").eq(index).removeClass("none");
                }
            },
            calFail: function (json) {
                $(".no_coupon").eq(index).removeClass("none");
                counponList[index] = [];
            }
        };
        LeHttp.send(options)
    },
    //如果从房号直签-签约-选择优惠券进来 index季付只会为0
    initCoupon: function (index) {
        if (commonJSCaller.getQuery().counponCodes) {

            // if (index == 0) {
            var codes = commonJSCaller.getQuery().counponCodes;
            counponCodes[index] = codes;
            codes = codes.split(',');
            var mount = 0, s = [];
            codes.forEach(function (el, i) {
                counponList[index].forEach(function (c) {
                    if (el == c.couponCode) {
                        s.push(c);
                    }
                });
            });
            mount = financeInvoker.convertCouponAmount(s, index);
            $('.has_coupon').eq(index).removeClass('none').addClass('c-red').find('span').html('- ￥' + mount);
            $(".no_coupon").eq(index).addClass("none");
            var allP = $('.goPay').eq(index).data('nopayment');
            $('.pay-total').eq(index).html(commonJSCaller.FloatSub(Number(allP), Number(mount)));
        }
        // }
    },
    //倒计时
    countingDown: function () {
        var now = nowTime;
        var _createTime = parseInt(expirationTime);
        if (_createTime - now >= 0) {
            var seconds = _createTime - now;
            //转化为hh:mm:ss
            var hh, mm, ss;
            mm = parseInt(seconds / 60);
            ss = seconds % 60;
            $("#counter").text((mm < 10 ? ("0" + mm) : mm) + ":" + (ss < 10 ? ("0" + ss) : ss))
            //开始倒计时
            this.setCountingDown($("#counter"), mm, ss);
        } else {
            //失效了
            this.resetStyle($("#counter"));//设置超时样式
        }
    },
    setCountingDown: function (cur, m, s) {
        var timer = timer;
        if (timer != null) {
            clearInterval(timer);
        }
        timer = setInterval(function () {
            if (s == 0) {
                if (m > 0) {
                    m -= 1;
                    s = 59;
                } else {
                    clearInterval(timer);
                    this.resetStyle(cur);//设置超时样式
                }
            }
            if (s > 0) s--;
            $(cur).text("" + (m < 10 ? ("0" + m) : m) + ":" + (s < 10 ? ("0" + s) : s))
        }, 1000);
    },
    //设置超时样式
    resetStyle: function (elm) {
        elm.parent().text("订单已超时，请重新下单").addClass("timeout");
        $(".finance-btn").addClass("disabled");
    },
    /**
     * @desc 获取详情
     */
    getDetail: function () {
        var name = "findContractBillForQuarterlyPayment";
        var param = {
            serviceCode: commonJSCaller.getQuery().serviceCode,
            contractId: commonJSCaller.getQuery().contractId || '',
            apartmentId: commonJSCaller.getQuery().apartment_id,
            billId: commonJSCaller.getQuery().contractBillId || '',
            paymentType: 2 //默认传2
        };
        var _this = this;
        commonJSCaller.showLoading()
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                commonJSCaller.hideLoading(function () {
                    expirationTime = json.data.expiredTime;
                    nowTime = json.data.currentTime;
                    couponSceneCode = json.data.billType;
                    var base = [], packs = [];
                    json.data.paymentPackageList.forEach(function (el, i) {
                        if (typeof el.list == 'object') {
                            el.list.forEach(function (l) {
                                l.subjectCode = l.subjectInfoId
                                l.amount = l.costAmount
                            })
                        }
                        if (el.list.length != 0) {
                            if (el.baseBillType == 1) {
                                base.push(el)
                            } else {
                                packs.push(el)
                            }
                        }
                    });
                    if (json.data.couponSupport == 1) {
                        base.forEach(function (el, i) {
                            financeInvoker.getCouponList(el, i);
                        })
                        packs.forEach(function (el, i) {
                            financeInvoker.getCouponList(el, i + base.length);
                        });
                    };
                    packages = base.concat(packs)
                    var dt = {
                        base: base,
                        data: packs,
                        isInstallment: json.data.isInstallment,
                        billPeriodBeginTime_f: LeUtil.Date.formatToDate(json.data.billPeriodBeginTime, 'yyyy/MM/dd'),
                        billPeriodEndTime_f: LeUtil.Date.formatToDate(json.data.billPeriodEndTime, 'yyyy/MM/dd'),
                        statementTime_f: LeUtil.Date.formatToDate(json.data.statementTime, 'yyyy/MM/dd'),
                    };
                    console.log(dt);
                    var tmp = template("all-temp", dt);
                    $("#all-pay").html(tmp);
                    setTimeout(function () {
                        $('.clickCoupon').click(function () { });
                        $('.show_detail').click(function () {
                        });
                    }, 0);
                    //倒计时开始
                    var scode = commonJSCaller.getQuery().serviceCode
                    if ($(".time-bar")[0] && (scode == 'rent' || scode == 'preordain' || scode == 'renew') && json.data.expiredSupport == 1) {
                        _this.countingDown();
                        $('.time-bar').show();
                    }
                    //支付参数
                    payUrl.serviceCode = json.data.serviceCode;
                    payUrl.contractBillId = json.data.billId;

                    //渲染不支持优惠券时的样式
                    json.data.paymentPackageList.forEach(function (el, i) {
                        if (json.data.couponSupport != 1) {
                            $('.has_coupon').eq(i).addClass('none');
                            counponList[i] = [];
                            $(".no_coupon").eq(i).removeClass("none");
                        }
                    });
                })
            },
            calFail: function (error) {
                commonJSCaller.hideLoading(function () {
                    alert(error.msg || '获取账单失败，请联系管家！')
                });
            }
        }
        LeHttp.send(options)
    }
};
function JsBridgeFinished() {
    financeInvoker.init();
}