var expirationTime = '';
var nowTime = parseInt(new Date().getTime()/1000);
var payUrl = commonJSCaller.getQuery();
var financeInvoker = {
    /**
     *
     * @param {*}
     */
    init:function() {
        this.bindEvt();
        this.getDetail();
    },
    bindEvt:function() {
        //支付
        $(document).on('click','.finance-btn',function(){
            if($(this).hasClass('disabled'))return;
            var cur = $(this), text = cur.text();
            btnJSCaller.setBtnLoading(cur);
            setTimeout(function(){
                btnJSCaller.resetBtnLoading(cur, text);
            },1600);
            var param = {
                contractBillId: payUrl.contractBillId,
                subjectInfoId: commonJSCaller.getQuery().subjectInfoId,
                serviceCode:payUrl.serviceCode,
                baseBillType:$(this).data('billtype')
            };
            payInvoker.preordainBillPayment(param, function (json) {
                if (json.data.status == 1) {
                    commonJSCaller.jumpClientApp('Cashier',{payURL: json.data.url,clearRouteList:1},function(){
                        //跳转首页
                        commonJSCaller.paySuccessRoute({},commonJSCaller.getQuery().serviceCode,'',1);
                    });
                } else {
                    //订单失效点击支付，提示订单已失效，从哪里来跳转那里去
                    alert(json.msg);
                    setTimeout(function () {
                        // location.href = '';
                    }, 2000)
                }
            });
        });
    },
    //倒计时
    countingDown:function() {
        var now = nowTime;
        var _createTime = parseInt(expirationTime);
        if (_createTime - now >= 0) {
            var seconds = _createTime - now;
            //转化为hh:mm:ss
            var hh, mm, ss;
            mm = parseInt(seconds / 60);
            ss = seconds % 60;
            $("#counter").text((mm < 10 ? ("0" + mm) : mm ) + ":" + (ss < 10 ? ( "0" + ss) : ss))
            //开始倒计时
            this.setCountingDown($("#counter"), mm, ss);
        } else {
            //失效了
            this.resetStyle($("#counter"));//设置超时样式
        }
    },
    setCountingDown:function(cur, m, s) {
        var timer = timer;
        if (timer != null) {
            clearInterval(timer);
        }
        timer = setInterval(function () {
            if (s == 0) {
                if (m > 0) {
                    m -= 1;
                    s = 59;
                } else {
                    clearInterval(timer);
                    this.resetStyle(cur);//设置超时样式
                }
            }
            if (s > 0) s--;
            $(cur).text("" + (m < 10 ? ("0" + m) : m ) + ":" + (s < 10 ? ( "0" + s) : s))
        }, 1000);
    },
    //设置超时样式
    resetStyle:function(elm) {
        elm.parent().text("订单已超时，请重新下单").addClass("timeout");
        $(".finance-btn").addClass("disabled");
    },
    /**
     * @desc 获取详情
     */
    getDetail:function() {
        var name = "findContractBillForQuarterlyPayment";
        var param = {
            serviceCode: commonJSCaller.getQuery().serviceCode,
            contractId:commonJSCaller.getQuery().contractId || '',
            apartmentId:commonJSCaller.getQuery().apartment_id,
            billId:commonJSCaller.getQuery().contractBillId || '',
            paymentType:2 //默认传2
        };
        var _this = this;
        commonJSCaller.showLoading()
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                commonJSCaller.hideLoading()
                json.data.statementTime_f = LeUtil.Date.formatToDate(json.data.statementTime,'yyyy-MM-dd');
                expirationTime = json.data.expiredTime;
                nowTime = json.data.currentTime;
                json.data.paymentPackageList.forEach(function (el, i) {
                    if(typeof el.list == 'object'){
                        el.list.forEach(function(l){
                            l.subjectCode = l.subjectInfoId
                            l.amount = l.costAmount
                        })
                    }
                });
                var dt = {
                    data:json.data
                };
                if(json.data.paymentPackageList.length == 0){
                    alert(json.data.msg)
                }
                var tmp = template("all-temp",dt);
                $("#all-pay").html(tmp);
                //倒计时开始
                if ($(".time-bar")[0]  && json.data.expiredSupport == 1) {
                    _this.countingDown();
                }
                //支付参数
                payUrl.serviceCode = json.data.serviceCode;
                payUrl.contractBillId = json.data.billId;
            },
            calFail: function (error) {
                commonJSCaller.hideLoading();
                alert(error.msg || '获取账单失败，请联系管家！')
            }
        }
        LeHttp.send(options)
    }
};
function JsBridgeFinished(){
    financeInvoker.init();
}