var isLefullIous = false;
var monthParams = {};

var monthsInvoker = {
    /**
     *
     * @param {*}
     */
    init:function() {
        this.bindEvt();
        this.getDetail();
    },
    bindEvt:function() {
        //确认分期
        $(document).on('click', '#submit', function () {
            //乐乎分期，点击确认弹出分期协议，确认分期协议后跳转分期账单页面
            //门店分期，只有一期，点击确认分期直接跳转分期账单页面（
            //一条数据是门店分期，三条是乐乎分期
            //乐乎分期 请求月付协议

            if (isLefullIous) {
                //请求并弹出分期协议
                monthsInvoker.getMonthRule();
            } else {
                //跳走去支付
                monthsInvoker.confirmInstallment();
            }
        });
        //分期协议确认分期
        $('#agrement').click(function () {
            //判断是否签名 没有则去前面
            monthsInvoker.isSign(function(){
                monthsInvoker.confirmInstallment();
            },function(){
                var sign_url = '/esign/index.html';
                commonJSCaller.jumpToWap(sign_url);
            });
        })
    },
    isSign:function(suc,fal){
        var name = "get_tenant_auth";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "client2",
            param: {
            },
            calSuc: function (json) {
                if(json.status == 1){
                    //签名了
                    suc();
                }
            },
            calFail: function (json) {
                if(json.status == 0){
                    //没有签名
                    fal();
                }
            }
        }
        LeHttp.send(options)
    },
    /**
     * @desc 获取详情
     */
    getDetail:function() {
        var name = "contractBillInstallmentPreview";
        var param = {
            serviceCode: commonJSCaller.getQuery().serviceCode,
            contractBillId: commonJSCaller.getQuery().contractBillId,
            installmentType:commonJSCaller.getQuery().installmentType
        };
        var _this = this;
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                json.data.installmetnBills.forEach(function (el, i) {
                    el.statementTime_f = LeUtil.Date.formatToDate(el.statementTime, 'yyyy-MM-dd');
                    el.statementBeginTime_f = LeUtil.Date.formatToDate(el.statementBeginTime, 'yyyy/MM/dd');
                    el.statementEndTime_f = LeUtil.Date.formatToDate(el.statementEndTime, 'yyyy/MM/dd');
                    el.billTerm_f = Utils.numberToChinese(el.billTerm)
                });
                monthParams = {
                    tenant_id:json.data.tenantId,
                    apartment_id:json.data.apartmentId,
                    contract_number:json.data.contractNumber,
                    contract_cycle:json.data.contractCycle,
                    c_begin_time:LeUtil.Date.formatToDate(json.data.contractBeginTime,'yyyy-MM-dd').replace(/-/g,"/"),
                    c_end_time:LeUtil.Date.formatToDate(json.data.contractEndTime,'yyyy-MM-dd').replace(/-/g,"/"),
                    ious_begin_time:LeUtil.Date.formatToDate(json.data.iousBeginTime,'yyyy-MM-dd').replace(/-/g,"/"),
                    rental:json.data.rental
                };
                var dt = {
                    data: json.data.installmetnBills,
                    base:json.data.baseBillSubject,
                    baseBillAmount:json.data.baseBillAmount
                };
                var uP = commonJSCaller.getQuery();
                if(uP.counponCodes){
                    dt.couponsTotal = '- ￥'+uP.couponsTotal;
                    dt.baseBillAmount = commonJSCaller.FloatSub(Number(dt.baseBillAmount),Number(uP.couponsTotal))
                }
                //private Integer installmentType; // 分期类型:1乐乎分期;2门店分期
                isLefullIous =commonJSCaller.getQuery().installmentType == 1;
                var tmp = template("month-temp", dt);
                $("#monthsList").append(tmp);
            },
            calFail: function () {
            }
        }
        LeHttp.send(options)
    },
    goBillPay:function(){
        var param = commonJSCaller.getQuery();
        var url = "/bill_pay.html";
        url = commonJSCaller.setQuery(url, param);
        // if (commonJSCaller.getQuery().fromlist) {
        //     //从房租账单来，后面的页面返回回到房租账单
        //     commonJSCaller.jumpToWap(url, {prePopUrl: '/view/contractList'});
        // } else {
            commonJSCaller.jumpToWap(url, {clearRouteList: 1});
        // }
    },
    /**
     * @desc 确认分期
     */
    confirmInstallment:function() {
        var name = "confirmInstallment";
        var param = {
            contractBillId: commonJSCaller.getQuery().contractBillId,
            installmentType:commonJSCaller.getQuery().installmentType
        };
        var cur = $('#submit'), text = cur.text();
        btnJSCaller.setBtnLoading(cur);
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                monthsInvoker.goBillPay();
            },
            calFail: function (res) {
                btnJSCaller.resetBtnLoading(cur, text);
                alert(res.msg || '分期失败')
            }
        };
        LeHttp.send(options)
    },
    /**
     * @desc 请求分期协议
     */
    getMonthRule: function () {
        ruleInvoker.getMonthsRule(monthParams, function (json) {
            var dt = json;
            //失败处理 m站返回格式不统一
            if (json.status == 0) {
                dt = json.message;
            }
            $("#md-content").html(dt);
            $("#modal-5").addClass("md-show");
        })
    }
};

function JsBridgeFinished(){
    monthsInvoker.init();
}