//定义服务

var payInvoker = {
    /**
     *
     * @param {*}
     */
    /**
     * @desc 账单支付 入住和续租支付成功都需要跳物业交割单，所以需要通过合同id获取交割单id，在这里统一处理
     */
    payContractBill(param,cal) {
        var np = JSON.parse(JSON.stringify(param));
        var codes = [];
        if(np.couponsCodes){
            //有优惠券
            var num = np.couponsCodes.split(',');
            num.forEach(function(el,i){
                var o = np.couponsCodes.split(',')[i]+'|'+np.counponSubjectId.split(',')[i]+'|'+np.counponAmount.split(',')[i]+'|'+np.discountAmount.split(',')[i]
                codes.push(o)
            })
            codes = codes.join(',');
        }else{
            codes = codes.join(',');
        }
        var data = {
            couponInfos:codes,
            contractBillId: np.contractBillId,
            subjectInfoId:np.subjectInfoId,
            serviceCode:np.serviceCode,
            baseBillType:np.baseBillType
        };
        if(np.payAmount){
            data.payAmount = np.payAmount;
            //谢生云说，输入分次的时候不要加优惠金额
            // if(np.couponsCodes){
            //     var allCoupons = 0;
            //     np.counponAmount.split(',').forEach(function(el){
            //         allCoupons = commonJSCaller.FloatAdd(allCoupons,Number(el))
            //     });
            //     data.payAmount = commonJSCaller.FloatAdd(data.payAmount,allCoupons);
            // }
        }

        var name = "contractBillPayment";
        var options = {
            name: name,
            apiList: payAPI["apiList"],
            serviceName: "micro",
            param: data,
            calSuc: function (json) {
                if(json.data.status == 3){
                    alert('该账单已支付！');
                    return false;
                }
                if (cal) {
                    cal(json);
                }else{
                    alert('支付成功')
                }
            },
            calFail: function (json) {
                alert('账单支付请求失败，请联系管家')
            }
        }
        LeHttp.send(options)
    },
    preordainBillPayment(param, cal,errcal) {
        var name = "preordainBillPayment";
        var options = {
            name: name,
            apiList: payAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                if(json.data.status == 3){
                    alert('该账单已支付！');
                    return false;
                }
                if (cal) {
                    cal(json)
                }else{
                    alert('支付成功')
                }
            },
            calFail: function (json) {
                if(errcal){
                    errcal(json)
                }else{
                    alert(json.msg);
                }
            }
        }
        LeHttp.send(options)
    },
    //获取物业交割单id
    getContractInfo(param, cal,errcal) {
        var name = "getContractInfo";
        var options = {
            name: name,
            apiList: payAPI["apiList"],
            serviceName: "client2",
            param: param,
            calSuc: function (json) {
                cal(json);
            },
            calFail: function (json) {
                cal({status:0})
            }
        }
        LeHttp.send(options)
    },
};
window.payInvoker = payInvoker;