/**
 * Created by luoyu on 17/8/2.
 */
var firstTrigger = false;

$('.rn .apartment').on('click', function () {
    if (cityAptList.length == 0) {
        // alert('网络较差，数据加载中');
        return false;
    }
    if ($(this).find('i.icon').hasClass('icon-dropdown_up1')) {
        $(this).find('i').removeClass('icon-dropdown_up1');
        $('.rn-select').show().addClass('slide-out-bottom').removeClass('slide-in-bottom');
        $('.rn-select').hide();
    } else {
        $(this).find('i').addClass('icon-dropdown_up1');
        $('.rn-select').show().removeClass('slide-out-bottom').addClass('slide-in-bottom');
    }
    //选中当前门店
    var apt_id = $(this).parent().attr("data-apartment-id"),
        city_id = $(this).parent().attr("data-city_id");
    if (typeof (city_id) == 'undefined') {
        $("#city_list li:eq(0)").trigger("click");
    } else {
        $("#city_list li[data-city_id=" + city_id + "]").trigger("click");
        $("#apt_list li[data-apartment-id=" + apt_id + "]").find(".iconfont").addClass("icon-iconset0126");
    }

});

//解决ios高系统按住空白部分使劲上滑下滑时，页面卡住
$(document).on('touchend',function(){
    if($('.slide-in-bottom').length==0)return;
    setTimeout(function(){
        window.scrollTo(0,0);
    },50)
})

$('.btn-search').on('click', function () {
    if ($(this).hasClass('on')) {
        getList();
    }
})
$('#roomno').on('input propertychange', function () {
    initBtnSearch()
})
$("#roomno").on('keypress', function (e) {
    var keycode = e.keyCode;
    if (keycode == '13') {
        e.preventDefault();
        //请求搜索接口
        getList();
    }
});

/**
 * @desc 搜索按钮状态
 */
function initBtnSearch() {
    var searchName = $("#roomno").val(),
        apartmentId = $('.rn').attr('data-apartment-id');
    if (apartmentId && searchName != '') {
        //按钮显示可以点击
        $('.btn-search').addClass('on')
    } else {
        $('.btn-search').removeClass('on')
    }
}

/**
 * @desc 签约|预定逻辑交互处理
 */
$(document).on('click', '.roomList a', function () {
    if ($('.qy').hasClass('is-loading') || $('.yd').hasClass('is-loading')) return;
    if ($(this).hasClass('disabled')) return;

    var cur = $(this), text = cur.text();
    var room_id = cur.attr('data-room_id');
    var row = {};
    $.each(searchResult, function (i, o) {
        if (o.room_id == room_id) {
            row = o;
        }
    });

    console.log(row);

    // return;

    var apartment_id = row.apartment_id,
        color_name = row.color_name,
        room_id = row.room_id,
        company_id = row.company_id,
        rental = row.rental,
        area = row.area,
        room_number = row.room_number,
        apartment_name = row.apartment_info.apartment_name,
        from_lisa = row.from_lisa;
    /*
     * @fun 增加实名认证跳转逻辑  如果实名认证并绑定手机号,则直接跳转附加信息,否则进入实名认证
     * @auth Jack
     * @date 2018-08-01
     */
    var jumpUrl = function (redirect_url, emergencyContact) {
        //实名认证
        setTimeout(function () {
            btnJSCaller.resetBtnLoading(cur, text);
        }, 1600);
        commonJSCaller.jumpClientApp('Certification', { emergencyContact: emergencyContact }, function () {
            //统一先跳转公约界面
            ruleInvoker.getAuthRule(apartment_id, function (j) {
                var param = {
                    type: 0,
                    apartmentId: apartment_id,
                    redirect_url: redirect_url
                };
                var url = "/rule.html";
                if (typeof j == 'object') {
                    //协议加载失败或者没有协议
                    url = redirect_url;
                    delete param.redirect_url;
                    delete param.type
                } else {
                    url = commonJSCaller.setQuery(url, param);
                }
                setTimeout(function () {
                    btnJSCaller.resetBtnLoading(cur, text);
                }, 500)
                commonJSCaller.jumpToWap(url, {});
            }, function () {
                btnJSCaller.resetBtnLoading(cur, text);
            });
        });
    };
    btnJSCaller.setBtnLoading(cur);
    if ($(this).hasClass('qy')) {
        var options = {
            name: "is_fdd",
            apiList: apartmentAPI['apiList'],
            serviceName: "lisa",
            param: { apartment_id: apartment_id },
            calSuc: function (json) {
                console.log(json);
                var title = apartment_name + "-" + color_name;

                var reurl = '/checkin.html?apartment_id=' + apartment_id
                    + '&title=' + title + '&room_id=' + room_id
                    + '&rental=' + rental
                    + '&room_number=' + room_number
                    + '&area=' + area
                    + '&checkInType=2'
                    ;
                jumpUrl(reurl, true);
            },
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                console.log(json);
                //调用失败
            }
        }
        LeHttp.send(options)
    } else {
        //预定 直接跳转
        var title = apartment_name + "-" + color_name;
        var reurl = '/book.html?apartment_id=' + apartment_id
            + '&title=' + title + '&room_id=' + room_id
            + '&rental=' + rental
            + '&company_id=' + company_id
            + '&room_number=' + room_number
            + '&area=' + area;
        jumpUrl(reurl, false);
    }
});

/**
 * @desc 根据房间号搜索
 */
function getList() {
    if (!$('.rn').attr('data-apartment-id')) {
        $("#page_tip").hide();
        $('#empty_data').show();
        $('#empty_data p').html('请先选择门店!');
        document.activeElement.blur();
        return false;
    }
    if (!$('#roomno').val()) {
        $('#empty_data').show();
        $("#page_tip").hide();
        $('#empty_data p').html('请输入房号!');
        document.activeElement.blur();
        return false;
    }

    var para = {
        apartment_id: $('.rn').attr('data-apartment-id'), //$('.rn').data('apartment-id')
        room_number: $('#roomno').val()
    }
    if (cityAptList.length > 0) {
        $('.rn-select').hide();
    };
    $('.rn .apartment').find('i').removeClass('icon-dropdown_up1').addClass('icon-icon_dropdown_line');
    var options = {
        name: "get_room",
        apiList: apartmentAPI['apiList'],
        serviceName: "lisa",
        param: para,
        calSuc: function (json) {
            if (json.data.length > 0) {
                $.each(json.data, function (i, o) {
                    $.each(o.imgs, function (m, n) {
                        n.resource_url = qiniuURL + n.resource_name;
                    })
                });
                searchResult = json.data;
                $('#empty_data').hide()
                $("#page_tip").hide();
                genListTemp(json);
            } else {
                $("#page_tip").hide();
                $('#empty_data').show();
                $('.roomList').html('');
                $('#empty_data p').html('抱歉！未能搜索到结果!');
                document.activeElement.blur();
            }
        },
        calFail: function () {
            $('#empty_data').show();
            $('.roomList').html('');
            $('#empty_data p').html('抱歉！未能搜索到结果!');
            document.activeElement.blur();
        }
    }
    LeHttp.send(options)

};

/**
 *
 * @param {*} dt
 * @desc 生成列表搜索结果
 */
function genListTemp(dt) {
    var json = {
        data: dt.data
    }
    var temp = template("list-temp", json);
    $("#roomList").html(temp);
}

//服务名称
var serviceName = "apartment";

//搜索结果
var searchResult = [];

//全部城市门店数据
var cityAptList = [];

/**
 * @desc 获取全部城市门店
 */
function getCityAptList() {
    var name = "get_cityapt";
    var options = {
        name: name,
        apiList: apartmentAPI['apiList'],
        serviceName: serviceName,
        param: { allLefullAndAllUpon: 1,notFilterIsOpen:1},
        calSuc: function (json) {
            var allApart= json.data;
            var optionsClose = {
                name: 'get_close_room',
                apiList: apartmentAPI['apiList'],
                serviceName: 'lisa',
                param: {},
                calSuc: function (res) {
                    for(var i=0;i<allApart.length;i++){
                        for(var j=0;j<allApart[i].apartmentList.length;j++){
                            var nid = allApart[i].apartmentList[j].apartmentId;
                            for(var z=0;z<res.data.length;z++){
                                if(nid == res.data[z].apartmentid){
                                    allApart[i].apartmentList[j].hide = 1;
                                }
                            }
                        }
                    }
                    cityAptList = allApart;
                    genCitytemp();
                    setCurrentApt();
                },
                calFail: function (err) {
                    //调用失败
                }
            }
            LeHttp.send(optionsClose)  
        },
        calFail: function (json) {
            //调用失败
        }
    }
    LeHttp.send(options)
}

/**
 * @desc 选中当前门店  app 带入 门店id
 */
function setCurrentApt() {
    var apt_id = commonJSCaller.getQuery().id || 10;
    var apt_store = {id:apt_id, name:''};
    $.each(cityAptList, function (i, o) {
        $.each(o.apartmentList, function (m, n) {
            if (n.apartmentId == apt_id) {
                apt_store.name = n.apartmentName;
                $("#city_list li[data-city_id=" + n.cityId + "]").trigger("click");
                firstTrigger = true;
                $("#apt_list li[data-apartment-id=" + apt_id + "]").trigger("click");
                firstTrigger = false;
            }
        })
    });
    localStorage.setItem('apartment',JSON.stringify(apt_store));
}

/**
 * @desc 生成城市temp
 */
function genCitytemp() {
    var citys = [];
    $.each(cityAptList, function (i, o) {
        var t = {};
        t["cityId"] = o.cityId;
        t["cityName"] = o.cityName;
        citys.push(t);
    });
    var json = {
        data: citys
    }
    var cityTemp = template("cityList-temp", json);
    $("#city_list").html(cityTemp);
    genAptTemp(citys[0].cityId);
    $('.apartment span').html('请选择社区').removeClass('loading');
}

/**
 * @desc 绑定点击城市获取门店事件
 */
function bindCityLiEvt() {
    $('.rn-city').on('click', "li", function () {
        var city_id = $(this).attr("data-city_id");
        $('.rn-city i').removeClass('icon-iconset0126');
        $(this).find('i').addClass('icon-iconset0126');
        var is_picked = $(".rn").attr("data-apartment-id");
        if (typeof (is_picked) == 'undefined') {
            $(".rn").attr("data-city_id", city_id);
        }
        genAptTemp(city_id);
    });
}

/**
 * @desc 绑定点击门店点击事件
 */
function bindCityAptEvt() {
    $('.rn-apart').on('click', "li", function () {
        $('.rn-apart i').removeClass('icon-iconset0126');
        $(this).find('i').addClass('icon-iconset0126');
        $('.rn-select').removeClass('slide-in-bottom').addClass('slide-out-bottom');
        $('.rn .apartment span').html($(this).find('span').html()).css({
            'color': '#252525',
            'font-weight': 500
        });
        $('.rn').attr('data-apartment-id', $(this).attr('data-apartment-id'));
        $('.rn').attr('data-city_id', $(this).attr('data-city_id'));

        $('.rn .apartment').find('i').removeClass('icon-dropdown_up1').addClass('icon-icon_dropdown_line');
        initBtnSearch()
        if (firstTrigger) return false;
        setTimeout(function () {
            $('.rn-select').hide();
        }, 700);
    });
}

/**
 * @desc 生成对应城市门店temp
 */
function genAptTemp(city_id) {
    var apts = [];
    $.each(cityAptList, function (i, o) {
        if (city_id == o.cityId) {
            apts = o.apartmentList;
        }
    });
    var json = {
        data: apts
    }
    var aptTemp = template("cityApt-temp", json);
    $("#apt_list").html(aptTemp);
}




function JsBridgeFinished() {
    bindCityLiEvt();
    bindCityAptEvt();
    getCityAptList();
}
