/*
 * @Author: Jack 
 * @Date: 2019-01-10 13:59:49 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-01-21 15:05:10
 */
/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-01-09 16:04:09
 */
//定义服务

var ruleInvoker = {
    /**
     *
     * @param {*}
     */
    init: function (stype, call, errcall) {
        var type = stype || commonJSCaller.getQuery().type;
        this.bindEvt(type);
        var that = this;
        $('#submit_rule').html('我同意该制度并自愿签署合同');
        switch (type) {
            case '1':
                $('.fix-b').show();
                console.log("退租协议");
                that.getSurrenderRule(commonJSCaller.getQuery(), call);
                break;
            case '2':
                $('.fix-b').show();
                that.getBookingRule(commonJSCaller.getQuery(), call);
                break;
            case '3':
                $('.fix-b').show();
                that.getRentContract(commonJSCaller.getQuery(), call);
                console.log("房屋租赁合同");
                break;
            case '4':
                $('.fix-b').show();
                console.log("分期协议");
                break;
            case '5':
                that.getCardContract(commonJSCaller.getQuery(), call);
                console.log("乐乎付费会员卡协议");
                break;
            default:
                $('.fix-b').show();
                //默认加载乐乎公约
                that.getAuthRule({}, call, errcall);
                break;
        }
    },
    isSign:function(suc,fal){
        var name = "get_tenant_auth";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "client2",
            param: {
            },
            calSuc: function (json) {
                if(json.status == 1){
                    //签名了
                    suc();
                }
            },
            calFail: function (json) {
                if(json.status == 0){
                    //没有签名
                    fal();
                }
            }
        }
        LeHttp.send(options)
    },
    bindEvt: function (type) {
        var gourl = ''
        $(window).scroll(function () {
            ruleInvoker.isAtBottom()
        });
        switch (type) {
            case '3':
                //房屋租赁合同
                gourl = '/checkin_finance.html'
                break;
            case '2':
                //定金协议
                gourl = '/book_pay.html'
                break;
            default:
                //默认跳转对应传递过来的界面地址
                gourl = location.href.split("redirect_url=")[1];
                break;
        }
        $('#submit_rule').click(function () {
            if ($(this).hasClass('disabled')) return;
            //调起支付
            if(type == 0){
                var ori_url = gourl;
            }else{
                var p = commonJSCaller.getQuery();
                delete p.type;
                var ori_url = commonJSCaller.setQuery(gourl, p);
            }
            var url = encodeURIComponent(ori_url);
            var sign_url = '/esign/index.html#/sign?url=' + url;
            ruleInvoker.isSign(function(){
                commonJSCaller.jumpToWap(ori_url);
            },function(){
                commonJSCaller.jumpToWap(sign_url);
            });
        });
    },
    /**
     * @desc 获取房屋租赁合同模板
     */
    getRentContract: function (param, cal) {
        var name = "get_contract";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: {
                apartment_id: param.apartment_id,
                room_id: param.room_id,
                deposit_month: param.deposit_month,
                rent_month: param.rent_month,
                term: param.term,
                contract_begin_time: param.contract_begin_time,
                contract_end_time: param.contract_end_time,
                rental: param.rental,
                service_free: param.service_free,
                deposit: param.deposit
            },
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },
    /**
     * @desc 获取乐乎会员卡协议
     */
    getCardContract: function (param, cal) {
        var name = "protocol";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: {

            },
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },
    /**
     *
     * @param {*} param
     * @param {*} cal
     */
    getBookingRule: function (param, cal) {
        var name = "get_book_rule";
        console.log(param)
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: {
                apartment_id: param.apartment_id
            },
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },
    /**
     * @desc 获取退租协议
     */
    getSurrenderRule: function (param, cal) {
        var name = "get_surrender_rule";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: {
                apartment_id: param.apartmentId,
                contract_id: param.contractId
            },
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },
    /**
     * @desc 获取分期协议
     */
    getMonthsRule: function (param, cal) {
        var name = "get_month_rule";
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: param,
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },

    /**
     * @desc 获取租客公约
     */
    getAuthRule: function (apartmentid, cal, errcal) {
        var name = "get_auth";
        var urlApartmentId = commonJSCaller.getQuery().apartmentId || commonJSCaller.getQuery().apartment_id;
        var param = {
            apartment_id: urlApartmentId || apartmentid
        };
        // if(!param.apartment_id)return;
        var options = {
            name: name,
            apiList: ruleAPI["apiList"],
            serviceName: "lisa",
            param: param,
            calSuc: function (json) {
                // console.log(json);
                if (cal) {
                    cal(json)
                } else {
                    $("#rule-show").html(json);
                }
                ruleInvoker.isAtBottom()
            },
            calFail: function (json) {
                if (errcal) {
                    errcal();
                }
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },

    /**
     * @desc 判断页面是否到底部
     */
    isAtBottom: function () {
        //滚动条所在位置的高度
        var totalheight = parseFloat($(window).height()) + parseFloat($(window).scrollTop());
        //当前文档高度   小于或等于   滚动条所在位置高度  则是页面底部
        if (($(document).height()) <= totalheight + 200) {
            //页面到达底部
            $('#submit_rule').removeClass('disabled');
        }
    }
};
if (location.href.indexOf('rule.html') > -1) {
    ruleInvoker.init();
}
window.ruleInvoker = ruleInvoker;