/**
 * Created by luoyu on 17/10/30.
 *  @fun 支付中心
 *  @update by jack
 */

//支付方式选择配置 测试数据

// var payWays = [];

// env = "h5"; //本次调试
// alert("当前环境:" + env);
// alert("页面输出数据:" + JSON.stringify(pageData));

console.log(env);

var ua = navigator.userAgent.toLowerCase();


//微信浏览器
function isWeixn() {
    if (ua.match(/MicroMessenger/i) == "micromessenger") {
        return true;
    } else {
        return false;
    }
}

//微信浏览器
function isAlipay() {
    if (ua.match(/Alipay/i) == "alipay") {
        return true;
    } else {
        return false;
    }
}

/*
 * 浏览器环境监测
 */

function getUserAgent() {
    if (isWeixn()) {
        env = "weixin";
    } else if (isAlipay()) {
        env = "alipay";
    } else {
        env = "h5";
    }
}


// getUserAgent(); //获取支付环境

// env = "h5";//测试


// env = "alipay";//测试环境


// var payConfig = JSON.parse(pageData); //接受页面支付方式

var payConfig =  pageData;

$.each(payConfig, function(i, o) {
    o.show = true;
});

// console.log(payConfig);

var payCenter = {

    initPage: function() {
        var that = this;
        that.iniData();
        that.bindCard();
        that.changeCard();
    },
    /*
     *@fun 银行卡管理
     *@auth Jack
     *@date 2018-07-24 17:01
     */
    bindCard: function(){
        $("#card-manage").click(function(){
            //是否选中银行卡
            var cur = $(this),
                type = cur.attr("data-type");
            if(type != 0){
                $("#slide-info").find(".active").removeClass("active");
                $("#slide-info a[data-type="+type+"]").addClass("active");
            }
            $("#overlay").removeClass("none");
            $("#slide-info").addClass("anim");
        });
        $("#cancel").click(function(){
            $("#overlay").addClass("none");
            $("#slide-info").addClass("slideInDown");
            setTimeout(function(){
                $("#slide-info").removeClass("slideInDown").removeClass("anim");
            },500)
        });
    },
    /*
     *@fun 切换银行卡、添加银行卡
     *@auth Jack
     *@date 2018-07-24 17:01
     */
    changeCard: function(){
        $(".card-item").click(function(){
            var cur = $(this),
                bank = cur.attr("data-bank"),
                card = cur.attr("data-card"),
                type = cur.attr("data-type-name");
            if(!cur.hasClass("active")){
                cur.parent().find(".active").removeClass("active");
                cur.addClass("active");
                setTimeout(function(){
                    var curBank = bank + " " + type + "(" + card + ")";
                    $("#cur-bank").text(curBank);
                    $("#cancel").trigger("click");
                },200);
            }
        });

        $("#add-new-card").click(function(){
            location.href = "http://baidu.com/";
        })
    },
    /*
     *@fun 筛选支付配置方式
     */
    iniData: function() {
        var that = this;
        switch (env) {
            case 'weixin':
                var dt = payConfig;
                $.each(dt, function(i, o) {
                    var name = o.pay_alias;
                    if (name == "支付宝") {
                        o.show = false;
                    }
                });
                that.genPayTemp(dt);
                break;
            case "alipay":
                var dt = payConfig;
                $.each(dt, function(i, o) {
                    var name = o.pay_alias;
                    if (name == "微信支付") {
                        o.show = false;
                    }
                });
                that.genPayTemp(dt);
                break;
            case "h5":
                var dt = payConfig;
                $.each(dt, function(i, o) {
                    o.show = false;
                });
                that.genPayTemp(dt);
                break;
            case "app":
                that.showAppPage();
                break;
            default:
                that.genPayTemp();
                break;
        }
    },
    //app支付方式筛选过滤
    showAppPage: function() {
        var that = this;
        if (typeof(JSBridge) != "undefined") {
            JSBridge.callHandler('getPayConfig', {}, function(res) {
                // alert(JSON.stringify(res));
                var dt = payConfig;
                $.each(dt, function(i, o) {
                    var name = o.pay_alias;
                    if (name == "支付宝") {
                        if (res.alipay == false) {
                            o.show = false;
                        }
                    } else if (name == "微信支付") {
                        if (res.wechat == false) {
                            o.show = false;
                        }
                    }
                });

                that.genPayTemp(dt);

            });
        }

        //模拟app返回
        //      var res = {
        //          alipay:false,
        //          wechat:false
        //      }
        //      var dt = payConfig;

        //      $.each(dt, function(i, o) {
        // var name = o.pay_alias;
        //          if (name == "支付宝") {
        //              if (res.alipay == false) {
        //               o.show = false;
        //           }
        //       }else if (name == "微信支付") {
        //           if (res.wechat == false) {
        //               o.show = false;
        //           }
        //       }
        //   });


        //      that.genPayTemp(dt);

    },
    //生成支付模板
    genPayTemp: function(dt) {
        var that = this;
        var source = dt != undefined ? dt : payConfig;

        //测试
        // source = [
        //     {
        //         pay_alias:"快捷支付",
        //         pay_channel:"SW",
        //         pay_way:"AS",
        //         scene_apartment_pay_id:"2293",
        //         show:true
        //     },
        //     {
        //         pay_alias:"支付宝",
        //         pay_channel:"SW",
        //         pay_way:"AS",
        //         scene_apartment_pay_id:"2293",
        //         show:true
        //     },{
        //         pay_alias:"微信",
        //         pay_channel:"SW",
        //         pay_way:"AS",
        //         scene_apartment_pay_id:"2293",
        //         show:true
        //     }
        // ]

        $.each(source,function(i,o){

            switch(o.pay_alias){
                case '支付宝':
                    o.pay_icon = 'alipay';
                    break;
                case '微信支付':
                    o.pay_icon = 'wx';
                    break;
                case '快捷支付':
                    o.pay_icon = 'bank';
                    break;
                default:
                    break;
            }

        })

        var json = {
            data: source
        };

        var tmp = template("payTmp", json);

        $("#payWay").html(tmp);

        setTimeout(function() {
            $(".boxLoading").removeClass("active").addClass("none");
            $(".wraper").removeClass("none");
        }, 600);

        that.bindEvt();

    },
    //事件绑定
    bindEvt: function() {
        //切换支付方式
        $('.pay-way').bind('click', function() {
            $('.pay-way').removeClass('on');
            $(this).addClass('on');
        });
        //立即支付
        $(".btnPay").click(function() {
            // JSBridge.callHandler('payViaNativeSPay', {
            //     tokenID: dt.token_id,
            //     services: "pay.weixin.app"
            // }, function(res) {
            //     // alert(res)
            //     var rs = JSON.parse(res);
            //     if(rs.status != 1 ){
            //         mkDialog(2,rs.message);//客户端支付失败
            //     }
            // });
            // JSBridge.callHandler('CallHandlerName',{

            // },function(res){

            // })

//                    //皮皮曹说的兼容新版的所以写两次
//                        JSBridge.callHandler('jsNavgationNative',
//                        { path:"/SmartDevice/ElectricActivity",data:"" },
//                        function(res) {
//                                                                        // alert(res)
//                                                                        var rs = JSON.parse(res);
//                                                                        if(rs.status != 1 ){
//                                                                            mkDialog(2,rs.message);//客户端支付失败
//                                                                        }
//                                                                    });


//皮皮曹说的兼容新版的所以写两次
                        JSBridge.callHandler('jsNavgationH5',
                        { path:"jsbridage/view/pay.html",data:{
                            title:"支付中心"
                        }},
                        function(res) {
                                                                        // alert(res)
                                                                        var rs = JSON.parse(res);
                                                                        if(rs.status != 1 ){
                                                                            mkDialog(2,rs.message);//客户端支付失败
                                                                        }
                                                                    });
            return;
            // if($(this).hasClass("disab")) return;


            // var len = $(".pay-way.on").length;


            // if (len == 0) {
            //     mkDialog(2, '请选择支付方式');
            //     return;
            // }


            // var cur = $(this),
            //     reqUrl = cur.attr("data-pay"),
            //     id = $(".pay-way.on").attr("data-id"),
            //     uuid = cur.attr("uuid"),
            //     url = $(".pay-way.on").attr("data-url");




            // if (url != "" && typeof(url) != "undefined") {
            //     window.location.href = url;
            //     return;
            // }

            mkDialog(0, '支付中');

            //非APP环境直接跳转服务端返回链接地址
            if (!cur.hasClass("clicked")) {
                cur.addClass("clicked");
                var dt = {};

                var res = payConfig;

                $.each(res, function(i, o) {

                    if (o.scene_apartment_pay_id == id) {
                        dt = o;
                    }

                });

                var name = dt.pay_alias;


                var data = {
                    uuid: uuid,
                    pay_channel: dt.pay_channel,
                    pay_way: dt.pay_way,
                    merchant_id: dt.merchant_id,
                }
                $.ajax({
                    type: "POST",
                    data: data,
                    url: reqUrl,
                    success: function(json) {
                        cur.removeClass("clicked");
                        json = JSON.parse(json);
                        if (json.status != 0) {
                            if (env == "app") {
                                //app的逻辑
                                //是否为微信 是微信调用app微信支付  否 和支付宝处理一样 打开外部链接
                                //处理逻辑
                                var dt = json.data;
                                if (typeof(JSBridge) != "undefined") {
                                    if (name == "微信支付") {
                                        switch (json.pay_channel) {
                                            case "SW":
                                                
                                                //皮皮曹说的兼容新版的所以写两次
//                                                 JSBridge.callHandler('payNativeWechat', {
//                                                     data: {
//                                                         tokenID: dt.token_id,
//                                                         services: "pay.weixin.app"
//                                                     },
//                                                     payChannel: dt.pay_channel,
//
//                                                 }, function(res) {
//                                                     // alert(res)
//                                                     var rs = JSON.parse(res);
//                                                     if(rs.status != 1 ){
//                                                         mkDialog(2,rs.message);//客户端支付失败
//                                                     }
//                                                 });
                                                break;
                                            case "AI":
                                                JSBridge.callHandler('payNativeWechat', {
                                                    data:JSON.parse(dt.weChatAPPInfo).weixinstr,
                                                    payChannel: json.pay_channel,

                                                }, function(res) {
                                                    // alert(res)
                                                    var rs = JSON.parse(res);
                                                    if(rs.status != 1 ){
                                                        mkDialog(2,rs.message);//客户端支付失败
                                                    }
                                                });
                                                break;
                                            default:
                                                break;
                                        }
                                    } else {
                                        //当为支付宝需要调用客户端打开链接
                                        if(name == '支付宝'){
                                            JSBridge.callHandler('openURL', {
                                                url: json.data
                                            }, function(res) {
                                                //alert(res)
                                            });
                                        }else{
                                            location.href = json.data
                                        }
                                    }
                                }

                            } else {
                                window.location.href = json.data;
                            }
                        } else {
                            mkDialog(2, json.message);
                        }
                    },
                    fail: function(json) {
                        json = JSON.parse(json);
                        cur.removeClass("clicked");
                        mkDialog(2, json.message);
                    }

                });

            }
        });
    }
}




$(document).ready(function() {
    setTimeout(function(){
        payCenter.initPage();
    },0);
});
