var front_json = '', back_json = '';
var type = commonJSCaller.getQuery().type || '';
var relations = [{ name: '父亲', id: 1 }, { name: '母亲', id: 2 }, { name: '儿女', id: 3 }, { name: '同事', id: 4 }, { name: '朋友', id: 5 }, { name: '兄妹', id: 6 }, { name: '其他', id: 7 }, { name: '配偶', id: 8 }];
var userPhone = ''
/**
 * @desc 关系初始化
 */
function initPicker() {
    //主
    $('#gx').mobiscroll('destroy');
    $('#gx_select').on('click', function () {
        $('#gx').mobiscroll('show');
    });
    $('#gx').mobiscroll().select({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom',
        onCancel() {
            if (type == 'auth' || type == 'contact') {
                //有可能第一次old没赋值上 old不可能为空
                if (!$('#gx_dummy').attr('old')) {
                    $('#gx_dummy').attr('old', getRelationNameById($('#interpersonal_relation_configuration_id').val()));
                }
            }
            $('#gx').val($('#gx_dummy').attr('old') ? $('#gx').val() : '');
            $('#gx_dummy').val($('#gx_dummy').attr('old') || '');
        },
        onSet: function (value) {
            $('#gx_dummy').attr('old', value.valueText);
            $('#interpersonal_relation_configuration_id').val($('#gx').val());
        }
    });
    if (type == '' || type == 'my') {
        $('#gx_dummy').val('').attr('placeholder', '请选择');
    }
}


/**
 * @desc 绑定事件
 */
function bindEvt() {

    //提交预定单
    $("#submit_order").off('click').click(function () {
        if ($(this).hasClass('disabled')) return;
        var cur = $(this), text = $(this).text();
        var form = {};
        $('input.ipt').each(function (el) {
            var name = $(this).attr('id'), value = $(this).val();
            form[name] = value;
        })
        if (type == '' || type == 'my') {
            if (form.id_card == '') {
                alert('请先上传身份证');
                return false;
            }
            if (form.phone == '') {
                alert('请填写主租人手机号');
                return false;
            }
            if (!/^1[0-9]{10}$/.test(form.phone)) {
                alert("手机格式错误请重新填写！");
                return;
            };
            if (form.mailing_address == '') {
                alert('请填写主租住人通讯地址')
                return false;
            }
        }
        if (form.emergency_contact == '') {
            alert('请填写紧急联系人姓名');
            return false;
        }
        if (form.emergency_phone == '') {
            alert('请填写紧急联系人手机号码');
            return false;
        }
        if (!/^1[0-9]{10}$/.test(form.emergency_phone)) {
            alert("手机格式错误请重新填写！");
            return;
        };
        if (form.emergency_phone != '' && form.emergency_phone == form.phone) {
            alert('主租人的紧急联系人不能为自己！');
            return false;
        }
        if (form.interpersonal_relation_configuration_id == '') {
            alert('请选择紧急联系人关系');
            return false;
        }
        //如果填写了单位电话，就要验证
        if (form.ec_work_unit_contact_phone) {
            if (!/^1[0-9]{10}$/.test(form.ec_work_unit_contact_phone)) {
                alert("主租人单位联系人手机格式错误，请重新填写！");
                return;
            };
        }
        form.front_json = front_json;
        form.back_json = back_json;

        btnJSCaller.setBtnLoading(cur);
        var options = {
            name: "getRealNameAuthentication",
            apiList: authAPI['apiList'],
            serviceName: "client2",
            param: form,
            datatype: "formdata",
            //成功执行
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                if (type == '' || type == 'my') {
                    alert('认证成功');
                };
                if (type == 'contact') {
                    alert('保存成功');
                }
                //跳转合租人
                if (type == '') {
                    var href = location.href;
                    href = href.replace('auth.html', 's_auth.html');
                    location.href = href;
                }
            },
            //错误执行
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                alert(json.message)
            }
        }
        LeHttp.send(options)
    });

    $('.auth-upload,.auth-img,.addWorkInfo').click(function () { });
    //ios bug
    $(document).off('blur','input').on('blur','input',function(){
        var scrollTop = $(document).scrollTop();
        window.scrollTo(0, scrollTop);
    })
    //点击工作信息
    $(document).off('click','.addWorkInfo').on('click','.addWorkInfo', function () {
        var toShow = $(this).next().css('display') == 'none';
        $(this).next().toggle();
        if (toShow) {
            $(this).find('span').html('收起工作信息')
        } else {
            $(this).find('span').html('添加工作信息')
        }
    });

    //上传身份证
    $(document).off('click','.auth-upload,.auth-img').on('click', '.auth-upload,.auth-img', function () {
        if (type) return;
        JSBridge.callHandler("startOCR", {}, function (json) {
            if (json) {
                var data = JSON.parse(json);
                getIdcardInfo(data);
            }
            console.log(json);
        })
    })
}


// 从app的扫描获取信息
function getIdcardInfo(data) {
    data.gender_f = data.gender;
    data.gender == '男' ? 1 : 2;
    data.mailing_address = data.address;
    data.qiniu = qiniu2[ENV];
    data.name = data.tenant_name;
    data.phone = userPhone;

    var dt = {
        data: data,
        relations: relations
    };
    var tmp = template("temp", dt);
    $("#html-temp").html(tmp);

    init();
    bindEvt();

    //初始化
    var re_id = data.interpersonal_relation_configuration_id;
    $('#gx').val(re_id);
    $('#gx_dummy').val(getRelationNameById(re_id));
    initPicker();

    front_json = data.front_json;
    back_json = data.back_json;
}

//查看实名认证
function getAuthInfo() {
    var options = {
        name: "getRealAuthInfo",
        apiList: authAPI['apiList'],
        serviceName: "client2",
        param: {},
        datatype: "formdata",
        //成功执行
        calSuc: function (json) {
            var data = json.data;
            data.qiniu = qiniu2[ENV];
            data.view = 1;
            var dt = {
                data: data,
                relations: relations
            };
            var tmp = template("temp", dt);
            $("#html-temp").html(tmp);
            init();
            bindEvt();

            //初始化
            var re_id = data.interpersonal_relation_configuration_id;
            $('#gx').val(re_id);
            $('#gx_dummy').val(getRelationNameById(re_id));
            initPicker();

            front_json = data.front_json;
            back_json = data.back_json;

        },
        //错误执行
        calFail: function (json) {
            btnJSCaller.resetBtnLoading(cur, text);
            alert(json.message)
        }
    }
    LeHttp.send(options)
}

function getRelationNameById(id) {
    var name = ''
    for (var i = 0; i < relations.length; i++) {
        if (relations[i].id == id) {
            name = relations[i].name
        }
    }
    return name
}


function init() {
    if (type == 'auth') {
        $('.type_auth').show();
        $('input[type="text"]').attr('disabled', true);
    } else if (type == 'contact') {
        $('.type_contact').show();
    } else {
        $('.type_order').show();
    }
}

if(type == 'contact'){
    document.title = '紧急联系人'
}


function JsBridgeFinished() {
    if (type == '' || type == 'my') {
        JSBridge.callHandler("checkUser", {}, function (res) {
            res = JSON.parse(res);
            userPhone = res.userPhone;
            var dt = {
                data: {phone:res.userPhone},
                relations: relations
            };
            var tmp = template("temp", dt);
            $("#html-temp").html(tmp);
            init();
            bindEvt();
            initPicker();
        });
    } else {
        getAuthInfo();
    }
}


