/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: hhs
 * @Last Modified time: 2019-10-28 15:48:00
 */
//提交参数
var modalForm = {
    apartment_id: "",
    room_id: "",
    rental: "",
    room_number: "",
    check_type: "",
    beginTime: "",
    contractPeriodReq: "",
    contractConfigReq: "",
    contractCycle: ""
}, noTemplate = false;
var onlyRentRise = '';
var nowDateStr = '';
var couponForm = {};//优惠券提交的参数
var counponCodes = '';//优惠券选中的code
var counponList = [];//优惠券列表
var signPeriod = []; //缓存签约周期、付款方式配置
var costData = []; //缓存费用科目信息
/**
 * @desc 请求入住协议
 */
function getCheckInRule() {
    function initScroll() {
        var myScroll;
        myScroll = new IScroll('#wrapper', { scrollY: true, scrollX: true, freeScroll: true });
    }
    var param = commonJSCaller.getQuery();
    param.term = JSON.parse(modalForm.contractPeriodReq).period;
    param.rent_month = JSON.parse(modalForm.contractConfigReq).rentMonth;
    param.deposit_month = JSON.parse(modalForm.contractConfigReq).depositMonth;
    param.contract_begin_time = modalForm.beginTime;
    var options = {
        name: "get_nex_pay_time",
        apiList: checkinAPI['apiList'],
        serviceName: "client",
        param: {
            isMinus: 1,
            month: param.term,
            begin_time: param.contract_begin_time
        },
        calSuc: function (json) {
            param.contract_end_time = json.data;
            ruleInvoker.getRentContract(param, function (json) {
                var dt = json;
                //失败处理 m站返回格式不统一
                if (json.status == 0) {
                    dt = json.message;
                }
                $("#scroller").html(dt);
                initScroll();
                //$("#md-content").html(dt);
            });
        },
        calFail: function () {
            param.contract_end_time = '';
            // console.log(json)
            //统一错误处理
        }
    }
    LeHttp.send(options)

}

/**
 * 获取合同配置 签约周期 押付方式
 */
function getContractConf(urlParams) {
    $('.s-loading').addClass('show');
    var para = {
        apartmentId: modalForm.apartment_id,
        isFormatDate: 1
    };
    var options = {
        name: "get_config",
        apiList: bookingAPI['apiList'],
        serviceName: "apartment",
        param: para,
        calSuc: function (json) {
            //组件初始化
            //预定转入住1 直接入住2 续租 3
            //预定转入住
            nowDateStr = json.responseTime.substr(0, 10);
            if (urlParams.checkInType == 1) {
                $("#yzr").text(foramtPeriod(urlParams.period)).attr("data-m", urlParams.period)
                var time = urlParams.date;
                initDatepicker(time);
            } else {
                //直接入住、续租
                $("#sign_period .iconfont,#sign_period #time").removeClass("none");
                initDatepicker();
            }

            $('.s-loading').removeClass('show');
            if (commonJSCaller.getQuery().checkInType == 1) {
                $("#yzr").removeClass('none')
            }
            if (json.data.contractConfigReq.length == 0 || json.data.contractPeriodReq.length == 0) {
                var txt = '入住';
                alert('该门店不支持' + txt + '业务，请联系管家。')
                return false;
            }
            signPeriod = json.data;
            onlyRentRise = json.data.onlyRentRise;
            genDropTemp(signPeriod);
            var param = commonJSCaller.getQuery();
            if (param.period) {
                changePeriod(Number(param.period))
            }
        },
        calFail: function (err) {
            $('.s-loading').removeClass('show')
            var error = err.data.msg || err.msg;
            alert(error || '获取签合约周期、付款方式失败，请重试');
            // console.log(json)
            //统一错误处理
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} m 月份
 * @desc 签约周期显示转换
 */
function foramtPeriod(m) {
    var period_f = "";
    if (m < 6 || m > 6 && m < 12) {
        period_f = m + "个月";
    } else if (m == 6) {
        period_f = "半年";
    } else if (m >= 12) {
        if (m % 12 == 0) {
            period_f = m / 12 + "年";
        } else {
            period_f = m + "个月";
        }
    }
    return period_f;
}

/**
 * @desc 获取费用科目
 */
function getCostData() {
    // var month = "";
    // $.each(signPeriod,function(i,o){
    //      if(o.contractPeriodId == id){
    //         discount = o.discountScale;
    //         month = o.period_f;
    //      }
    // });
    // if(month.indexOf("年")> '-1'){
    //     month = Number(month.replace("年","")) * 12;
    // }else if(month.indexOf("个月") > '-1'){
    //     month = Number(month.replace("个月",""));
    // }

    $("#wgt-cost").html('');
    $("#total-pay").text('').attr('data-money', '');
    $('#submit').addClass('disabled');

    if (!$('#time_dummy').val() && !$("#yzr").attr("data-m")) {
        return false;
    }
    if (!$('#pay_way').val()) {
        return false;
    }

    var payJson = {};
    var periodJson = {};
    var period;
    var payway = $("#pay_way").val();
    ;

    //不同场景取值
    if (modalForm.check_type != 1) {
        period = $("#time").val(); //id
        $.each(signPeriod.contractPeriodReq, function (i, o) {
            if (o.contractPeriodId == period) {
                periodJson = o;
            }
        });

    } else {
        //预定转入住
        period = $("#yzr").attr("data-m"); //周期
        $.each(signPeriod.contractPeriodReq, function (i, o) {
            if (o.period == period) {
                periodJson = o;
            }
        });
    }
    //反查押付配置完整obj
    $.each(signPeriod.contractConfigReq, function (i, o) {
        if (o.contractConfigId == payway) {
            payJson = o;
        }
    });
    //请求费用科目
    var para = {
        contractPeriodReq: JSON.stringify(periodJson),
        contractConfigReq: JSON.stringify(payJson),
        apartmentId: modalForm.apartment_id,
        roomId: modalForm.room_id,
        checkInType: modalForm.check_type,
        rental: modalForm.rental
    }
    if (onlyRentRise !== undefined) {
        para.onlyRentRise = onlyRentRise;
    }

    modalForm.contractPeriodReq = para.contractPeriodReq;
    modalForm.contractConfigReq = para.contractConfigReq;

    getCheckInRule();
    commonJSCaller.showLoading();
    var options = {
        name: "get_checkIn_cost",
        apiList: checkinAPI['apiList'],
        serviceName: "tenancy",
        param: para,
        datatype: "json",
        calSuc: function (json) {
            //数据处理
            //"costType": 0, 1:收入;2:支出
            //"payType": 1, 1:一次性收入, 2:每月收入
            commonJSCaller.hideLoading(function () {
                var res = json.data;
                var list = res.subjectList;
                costData = res;
                if (list.length > 0) {
                    $.each(list, function (i, o) {
                        if (o.payType == 1) {
                            o.period = periodJson.period;
                        } else {
                            o.period = payJson.rentMonth;
                        }
                    });
                    var dt = {
                        data: list
                    }
                    var temp = template("subject-temp", dt);
                    $("#wgt-cost").html(temp);
                    $("#submit").removeClass('disabled');
                } else {
                    alert('该门店未配置支付场景');
                    $("#submit").addClass('disabled');
                }
                $("#total-pay").text(res.totalMoney).attr('data-money', res.totalMoney);

                //获取科目费用成功后再获取优惠金额
                getCouponList(periodJson.period, list);
            });
        },
        calFail: function (err) {
            //失败处理
            commonJSCaller.hideLoading(function () {
                alert(err.msg)
            });
            $("#wgt-cost").html("");
            $("#submit").addClass('disabled');
            $("#no_coupon").removeClass("none");
        }
    }
    LeHttp.send(options)
}

/**
 * @desc 获取可用优惠
 */
function getCouponList(month, subject) {
    var c = {};
    $.each(subject, function (i, o) {
        c[o.subjectId.toString()] = o.subjectAmount;
    });
    var para = {
        apartmentId: modalForm.apartment_id,
        useChannelCode: "lefull-tenant-app",
        sceneCode: SCENECODE["rent"],
        subjectNumberAndMoneyJsonStr: JSON.stringify(c),
        contractCycle: month
    };
    modalForm.contractCycle = month;
    couponForm = para;
    var options = {
        name: "get_coupon",
        apiList: checkinAPI['apiList'],
        serviceName: "marketing",
        param: para,
        datatype: "json",
        calSuc: function (json) {
            var cous = [];
            if (json.data.length > 0) {
                json.data.forEach(function (el, i) {
                    el.list.forEach(function (l) {
                        cous.push(l);
                    })
                });
                $('#has_coupon').html(cous.length + '张优惠券可用').removeClass('none');
                $('#has_counpon_icon').removeClass('none');
                $("#no_coupon").addClass("none");
                counponList = cous
            } else {
                $('#has_coupon,#has_counpon_icon').addClass('none');
                counponList = [];
                $("#no_coupon").removeClass("none");
            }
        },
        calFail: function (json) {
            $("#no_coupon").removeClass("none");
            counponList = [];
        }
    };
    LeHttp.send(options)
}

/**
 *
 * @param {*} data
 * @desc 生成签约周期、付款方式模板
 */
function genDropTemp(data) {
    //签约周期
    $.each(data.contractPeriodReq, function (i, o) {
        o.period_f = foramtPeriod(o.period);
    })
    var json = {
        data: data.contractPeriodReq
    }
    var tmp = template("period-temp", json);
    $("#time").html(tmp);

    //付款方式
    var dt = {
        data: data.contractConfigReq
    };
    var tmp = template("payway-temp", dt);
    $("#pay_way").html(tmp);

    //判断签约周期
    if (modalForm.check_type != 1) {
        initPeriod();
    }
    initPicker();
    // getCostData();

}

function formatDate(v) {
    return v < 10 ? "0" + v : v;
}

/**
 * @desc 最晚入住日期限制
 * check_type == 1定转入住  且  取值范围 今日 ~ 最晚签约日期 签约周期不能修改
 */
function initDatepicker(time) {
    var today14 = LeUtil.Date.DateAdd('d', 14, nowDateStr ? new Date(nowDateStr) : new Date());
    var min = "", bl = true,
        max = "", defaultMax = today14.replace(/\//g, "-"),
        now = nowDateStr ? new Date(nowDateStr) : new Date();

    if (time) {
        //限制
        //如果now >= time 取time 且不能更改
        //否则 日期范围为 now <= range <= time
        var today = now.getFullYear() + "-" + formatDate((now.getMonth() + 1)) + "-" + formatDate(now.getDate());
        var timeStamp = Date.parse(today) / 1000,
            maxStamp = Date.parse(time) / 1000;
        if (timeStamp >= maxStamp) {
            $("#now_date").text(time).removeClass("none");
            bl = false;
        } else {
            min = new Date(now.getFullYear(), now.getMonth(), now.getDate());
            time = time.indexOf('-') > -1 ? time.split("-") : time.split("/");
            max = new Date(time[0], time[1] - 1, time[2]);
        }
        modalForm.beginTime = time;
    } else {
        min = new Date(now.getFullYear(), now.getMonth(), now.getDate());
    }
    if (!max) {
        var maxarr = defaultMax.split('-');
        max = new Date(maxarr[0], maxarr[1] - 1, maxarr[2]);
    }
    if (bl) {
        $('#checkin_time').mobiscroll().date({
            theme: 'mobiscroll',
            lang: 'zh',
            display: 'bottom',
            mode: 'scroller',
            dateFormat: "yyyy-mm-dd",
            min: min,
            max: max,
            minWidth: 50 * $('html').attr('data-dpr'),
            onSet: function (valueText, inst) {
                var picker = valueText.valueText;
                //更新提交参数
                modalForm.beginTime = picker;
                if (!$('#time_dummy').val() && !$("#yzr").attr("data-m")) {
                    return false;
                }
                if (!$('#pay_way_dummy').val()) {
                    return false;
                }
                getCheckInRule();
            }
        });
        var today = LeUtil.Date.formatToDate(now.getTime(), 'yyyy-MM-dd');
        $('#checkin_time').val(today).css('color', '#333');
        modalForm.beginTime = today;
        $("#checktime_range .iconfont,#checkin_time").removeClass("none");
    }
}

/**
 * @desc 当为定转入住时 无法修改签约周期
 */
function initPeriod() {
    //签约周期
    $('#time').mobiscroll().select({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom',
        onCancel() {
            $('#time_dummy').val($('#time_dummy').attr('old') || '');
        },
        onSet(value) {
            var month = value.valueText;
            $('#time_dummy').attr('old', month);
            if (month.indexOf("年") > '-1') {
                if (month.indexOf("半年") > -1) {
                    month = 6
                } else {
                    month = Number(month.replace("年", "")) * 12;
                }
            } else if (month.indexOf("个月") > '-1') {
                month = Number(month.replace("个月", ""));
            }

            //重置优惠券
            if (counponList.length > 0) {
                $('#has_coupon').html(counponList.length + '张优惠券可用').removeClass('none').removeClass('c-red');
                $('#has_counpon_icon').removeClass('none');
                $("#no_coupon").addClass("none");
                counponCodes = '';
            }

            changePeriod(month);

        }
    });
    $('#time_dummy').val('').attr('placeholder', '请选择');
    $('#sign_period').on('click', function () {
        $('#time').mobiscroll('show');
    });
}

function changePeriod(month) {
    var dt = {
        data: signPeriod.contractConfigReq
    };

    //筛选小于等于签约周期的付款方式
    var payConfigReq = [], disabled = false;
    signPeriod.contractConfigReq.forEach(function (el, i) {
        if (Number(el.rentMonth) <= month) {
            payConfigReq.push(el);
        }
    });
    dt.data = payConfigReq;


    if (month >= 3) {
        var resPayConfig = []
        //第二版阿东需求：判断合同周期大于三个月时，付款方式里allowLessThreeMonth = 1的才显示
        //第三版晶晶需求：判断合同周期>=3时，付款方式里allowLessThreeMonth = 1才显示
        payConfigReq.forEach(function (el, i) {
            if (el.allowLessThreeMonth == 1) {
                resPayConfig.push(el);
            }
        });
        dt.data = resPayConfig;
    }
    ;

    if (dt.data.length == 0) {
        disabled = true
    }

    var tmp = template("payway-temp", dt);
    $("#pay_way").html(tmp).val('');

    initPicker(disabled);
    getCostData();
}

/**
 * @desc 初始化固定下拉框选择
 */
function initPicker(disabled) {
    //押付方式
    $('#pay_way').mobiscroll('destroy');
    $('#contract_pay').on('click', function () {
        $('#pay_way').mobiscroll('show');
    });
    if (disabled) {
        $('#pay_way_dummy').val('').attr('placeholder', '无付款方式')
    } else {
        $('#pay_way').mobiscroll().select({
            theme: 'mobiscroll',
            lang: 'zh',
            display: 'bottom',
            onCancel() {
                $('#pay_way_dummy').val($('#pay_way_dummy').attr('old') || '');
            },
            onSet: function (value) {
                //重置优惠券
                $('#pay_way_dummy').attr('old', value.valueText);
                if (counponList.length > 0) {
                    $('#has_coupon').html(counponList.length + '张优惠券可用').removeClass('none').removeClass('c-red');
                    $('#has_counpon_icon').removeClass('none');
                    $("#no_coupon").addClass("none");
                    counponCodes = '';
                }
                getCostData();
            }
        });
        $('#pay_way_dummy').val('').attr('placeholder', '请选择')
    }

}

// 根据科目id获取对应key值
function getFeeBySubjectId(id){
    var l = '';
    for(var i=0;i<costData.subjectList.length;i++){
        var o = costData.subjectList[i];
        if(o.subjectId == id){
            l = o.subjectAmount
        }
    };
    return l;
}

/**
 * 初始化事件绑定
 */
function bindEvt() {
    //预览协议
    $(".preview").click(function () {
        if (!$('#time_dummy').val() && !$("#yzr").attr("data-m")) {
            alert('请选择签约周期');
            return false;
        }
        if (!$('#pay_way_dummy').val()) {
            alert('请选择付款方式');
            return false;
        }
        $("#modal-5").addClass("md-show");
    });
    //点击优惠券
    $('#clickCoupon').click(function () {
        if (counponList.length == 0) return;
        var f = JSON.parse(JSON.stringify(couponForm));
        f.subjectList = [];
        f.selected = counponCodes;
        costData.subjectList.forEach(function (el, i) {
            f.subjectList.push({
                subjectId: el.subjectId,
                count: 1,
                money: el.subjectAmount
            })
        });
        commonJSCaller.jumpClientApp('CouponList', f, function (res) {
            // var res = [{
            //     "apartmentId":"87",
            //     "apartmentName":"test博爱路",
            //     "backMode":0,
            //     "contractCycle":"",
            //     "couponCode":"15528991654182110coupon",
            //     "couponId":"7ce7afa6f4324a94a54e50c3471e5e87",
            //     "couponPackageId":"",
            //     "couponTemplateId":"",
            //     "couponTemplateName":"服务费小雨优惠券",
            //     "discountForm":"00",
            //     "discountMoney":100.00,
            //     "discountRatio":0.00,
            //     "endTime":1552579199,
            //     "phone":"13540094569",
            //     "reachMoney":0.00,
            //     "remark":"",
            //     "sceneCode":"rent",
            //     "startTime":1551024000,
            //     "subjectName":"服务费",
            //     "subjectNumber":"5",
            //     "tenantId":"65095",
            //     "useChannelCode":"lefull-lisa-app,lefull-lisa-pc,lefull-tenant-app"
            //
            // }];
            var codes = [];
            var allP = $('#total-pay').attr('data-money');
            res.forEach(function (el, i) {
                codes.push(el.couponCode);
            });
            counponCodes = codes.join(',');
            renderSubjectCoupon(res);
            if (codes.length == 0) {
                $('#has_coupon').html(counponList.length + '张优惠券可用').removeClass('none').removeClass('c-red');
                $('#has_counpon_icon').removeClass('none');
                $("#no_coupon").addClass("none");
                $('#total-pay').html(parseFloat(Number(allP)));
                return false;
            }
        });
    });
    //提交入住单
    $("#submit").click(function () {
        var cur = $(this), text = cur.text();
        var para = {
            apartmentId: modalForm.apartment_id,
            roomId: modalForm.room_id,
            totalMoney: costData.totalMoney,
            beginTime: modalForm.beginTime.replace(/\//g, "-"),//入住日期
            subjectListRespList: JSON.stringify(costData.subjectList),
            checkInType: modalForm.check_type,
            rental: costData.rental,
            discountScale: costData.discountScale,
            serviceFee: costData.serviceFee,
            contractPeriodReq: modalForm.contractPeriodReq,
            contractConfigReq: modalForm.contractConfigReq,
            apartmentName: modalForm.apartmentName,
            roomNumber: modalForm.room_number
        };
        if (onlyRentRise !== undefined) {
            para.onlyRentRise = onlyRentRise;
        }
        if (!para.beginTime) {
            alert('请选择入住日期');
            return false;
        }
        if (!$('#time_dummy').val() && !$("#yzr").attr("data-m")) {
            alert('请选择签约周期');
            return false;
        }
        if (!$('#pay_way_dummy').val()) {
            alert('请选择付款方式');
            return false;
        }
        if (cur.hasClass('disabled')) return;
        btnJSCaller.setBtnLoading(cur);
        var options = {
            name: "add_checkin",
            apiList: checkinAPI['apiList'],
            serviceName: "tenancy",
            param: para,
            datatype: "formdata",
            //成功执行
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                var url = "/rule.html";
                if (noTemplate) {
                    url = "/checkin_finance.html";
                }
                var p = {
                    type: 3,
                    apartment_id: modalForm.apartment_id,
                    room_id: modalForm.room_id,
                    deposit_month: JSON.parse(modalForm.contractConfigReq).depositMonth,
                    rent_month: JSON.parse(modalForm.contractConfigReq).rentMonth,
                    term: JSON.parse(modalForm.contractPeriodReq).period,
                    contract_begin_time: para.beginTime,
                    contract_end_time: json.data.endTime,
                    rental: getFeeBySubjectId('1000000001'),
                    service_free:getFeeBySubjectId('5'),
                    deposit:getFeeBySubjectId('1000000003'),
                    serviceCode: json.data.serviceCode,
                    contractId: json.data.contractId,
                    contractBillId: json.data.contractBillId,//227b86ad535a335c341eeee498ad1a30
                    counponCodes: counponCodes,
                    contractCycle: modalForm.contractCycle,
                    fromh5: 1,

                };
                url = commonJSCaller.setQuery(url, p);
                commonJSCaller.jumpToWap(url, { clearRouteList: 1 });
            },
            //错误执行
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                console.log(json.msg);
                // if(json.code == 500){
                //     alertContro.alertText({desc:json.msg});
                //     return false;
                // }
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    });
}

function renderSubjectCoupon(data) {
    var total = 0;
    var allP = $('#total-pay').attr('data-money');
    if (data.length == 0) {
        $('.coupon').remove();
        return false;
    }
    var suj = {}, str = [];
    data.forEach(function (el, i) {
        // if (!suj[el.subjectNumber]) {
        //     suj[el.subjectNumber] = 0;
        // }
        // ;
        if (!suj[el.subjectNumber]) {
            suj[el.subjectNumber] = { amount: 0 };
        }
        suj[el.subjectNumber].amount = commonJSCaller.FloatAdd(suj[el.subjectNumber].amount, Number(el.discountMoney));
        suj[el.subjectNumber].name = el.subjectName
    });

    //判断科目费用是否小于优惠券费用，小于则优惠券 == 科目费用
    for (var key in suj) {
        costData.subjectList.forEach(function (el) {
            if (el.subjectId == key && el.subjectAmountStr < suj[key].amount) {
                suj[key].amount = el.subjectAmountStr
            }
        });
        total = commonJSCaller.FloatAdd(total, Number(suj[key].amount));
        str.push(suj[key].name + ' ¥' + suj[key].amount);
    }

    console.log(suj)

    str = str.join('，');

    var html = '<div class="flex label">' +
        '<p>优惠' + '*' + data.length + '</p>' + '<p class="sub-desc">' + str + '</p>' +
        '</div><div class="desc">' + '-¥' + total + '</div>';
    if ($('.coupon').length > 0) {
        $('.coupon').html(html);
    } else {
        $('#wgt-cost .wgt-c').append('<div class="d-flex icon-fee coupon">' + html + '</div>');
    }

    if (data.length > 0) {
        $('#has_coupon').html('- ￥' + total).addClass('c-red');
        $('#total-pay').html(commonJSCaller.FloatSub(Number(allP), total));
    }
}


/**
 * @desc 页面地址初始化
 */
function initPage() {
    var param = commonJSCaller.getQuery();

    if (param.period) {
        param.period = Number(param.period);
    }
    //页面传递参数赋值
    modalForm.apartment_id = param.apartment_id;
    modalForm.room_id = param.room_id;
    modalForm.rental = param.rental;
    modalForm.room_number = param.room_number;
    modalForm.check_type = param.checkInType; //入住类型


    modalForm.apartmentName = param.title.split("-")[0];//合并了只取门店名称

    console.log(modalForm)

    //初始化入住日期选择限制
    $("#apt_title").text(param.title);
    $("#apt_room .iconfont").after(param.room_number);
    $("#apt_price .iconfont").after("¥" + param.rental + "/月");
    $("#apt_area .iconfont").after(param.area);
    //获取签约周期、押付方式
    getContractConf(param);
}

function JsBridgeFinished() {
    initPage();
    bindEvt();
    commonJSCaller.getOnlineCardApartment();
    ruleInvoker.init(0, function (j) {
        if (typeof j == 'object') {
            //协议加载失败或者没有协议
            noTemplate = true
        }
    });
}
