var expirationTime = '';
var nowTime = parseInt(new Date().getTime() / 1000);
var contracBillId = '';
var contractId = '';
var couponForm = [{}];//优惠券组提交的参数
var counponCodes = [];//优惠券组选中的code
var counponList = [[]];//优惠券列表组
var installmentType = ''// // 分期类型:1乐乎分期;2门店分期
var monthsPackages = [];//月付分期科目
var fullPackages = [];//全额支付科目
var paramsUrl = commonJSCaller.getQuery();
var payUrl = JSON.parse(JSON.stringify(commonJSCaller.getQuery()));
var couponSceneCode = '';
var supportPay = false;
var financeInvoker = {
    /**
     *
     * @param {*}
     */
    init: function () {
        this.getDetail();
        this.getApartmentSurportPay();
    },
    getApartmentSurportPay: function () {
        var name = "getApartmentAppOpen";
        var param = {
            apartment_id: paramsUrl.apartment_id
        };
        var _this = this;
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "client2",
            param: param,
            calSuc: function (json) {
                if (json.data == 0) {
                    //没有开通线上支付
                    supportPay = false;
                } else {
                    supportPay = true;
                }
            },
            calFail: function (error) {
                alert(error.message || '获取门店是否开通线上支付失败，请联系管家！')
            }
        }
        LeHttp.send(options)
    },
    getTotalCouponMoneyByCode: function (index) {
        var mount = [];
        var coupons = [];
        if (counponCodes[index]) {
            counponCodes[index].split(',').forEach(function (el, i) {
                counponList[index].forEach(function (c) {
                    if (c.couponCode == el) {
                        coupons.push(c)
                    }
                });
            });
        }
        coupons.forEach(function (el) {
            mount.push(financeInvoker.convertCouponAmount([el], index))
        });
        return mount.join(',');
    },
    getAllCoupon: function (index) {
        var arr = financeInvoker.getTotalCouponMoneyByCode(index);
        var all = 0;
        arr.split(',').forEach(function (el) {
            all = commonJSCaller.FloatAdd(all, Number(el));
        });
        return all
    },
    goNoPayResult: function () {
        var url = "/pay_result.html";
        var param = {
            payTime: $('#payTime').html(),
            contractId: contractId || 'none',
            serviceCode: ''
        };
        url = commonJSCaller.setQuery(url, param);
        commonJSCaller.jumpToWap(url);
    },
    bindEvt: function () {
         //展示金额详细
         $(document).on('click','.show_detail',function(){
            var cur = $(this);
            $(this).find('.iconfont').toggleClass('icon-xiangshangjiantou').toggleClass('icon-xiangxiajiantou');
            if (cur.hasClass("active")) {
                cur.removeClass("active");
                cur.next().slideUp(200);
            } else {
                cur.addClass("active");
                cur.next().slideDown(200);
            }
        });
        //切换分期和全额
        $('.finance-tab').click(function () { });
        $(document).on('click', '.finance-tab', function () {
            $('.finance-tab').removeClass('on');
            $('.iconfont').removeClass('c-gren icon-xuanzhong').addClass('c-grey icon-weixuanzhong');
            $(this).addClass('on').find('.iconfont').removeClass('c-grey icon-weixuanzhong').addClass('icon-xuanzhong c-gren');
            var index = $(this).index() - 1;
            $('.ui-btn-green').addClass('none').eq(index).removeClass('none');
        })
        //去分期
        $(document).on('click', '#goMonthPay', function () {
            if ($(this).hasClass('disabled')) return;
            if (!supportPay) {
                financeInvoker.goNoPayResult();
                return false;
            }
            var param = {
                apartment_id: paramsUrl.apartment_id,
                contractBillId: paramsUrl.contractBillId,
                serviceCode: paramsUrl.serviceCode,
                contractCycle: paramsUrl.contractCycle,
                contractId: paramsUrl.contractId,
                installmentType: installmentType,
                counponCodes: counponCodes[0] || '',
                couponsTotal: $('.has_coupon').data('coupon') || ''
            };
            if (paramsUrl.fromlist) {
                param.fromlist = 1;
            }
            if (paramsUrl.fromh5) {
                param.fromh5 = 1;
            }
            var url = "/monthplan.html";
            url = commonJSCaller.setQuery(url, param);
            commonJSCaller.jumpToWap(url);
        });
        //点击优惠券
        $(document).on('click', '.clickCoupon', function () {
            var index = $(this).parents('.finance-tab').index() - 1;
            if (counponList[index].length == 0) return;
            var f = JSON.parse(JSON.stringify(couponForm[index]));
            f.selected = counponCodes[index] || ''
            commonJSCaller.jumpClientApp('CouponList', f, function (res) {
                // var res = [{
                //     "couponCode":"15555659794520HYCcoupon",
                //     "discountMoney":5,
                //     "subjectName":"租金",
                //     "subjectNumber":"1000000001"
                // }];
                console.log(res);
                var codes = [], couponAmount = 0;
                var allP = $('.pay-total').eq(index).data('total');
                couponAmount = financeInvoker.convertCouponAmount(res, index);
                res.forEach(function (el, i) {
                    codes.push(el.couponCode);
                });
                counponCodes[index] = codes.join(',');
                if (codes.length == 0) {
                    $('.has_coupon').eq(index).html(counponList[index].length + '张优惠券可用').removeClass('none').removeClass('c-red');
                    $(".no_coupon").eq(index).addClass("none");
                    if (!($('.finance-tab').length == 2 && index == 0)) {
                        $('.pay-total').eq(index).html(allP);
                    }
                    return false;
                }
                $('.has_coupon').eq(index).removeClass('none').addClass('c-red').html('<span>- ￥' + couponAmount + '</span><i class="icon-right"></i>').attr('data-coupon', couponAmount);
                if (!($('.finance-tab').length == 2 && index == 0)) {
                    $('.pay-total').eq(index).html(commonJSCaller.FloatSub(Number(allP), Number(couponAmount)));
                }
            });
        });

        // 全额支付
        $(document).on('click', '.goPay', function () {
            if ($(this).hasClass('disabled')) {
                return false;
            };
            if (!supportPay) {
                financeInvoker.goNoPayResult();
                return false;
            }
            var url = '/bill_pay.html';
            var p = commonJSCaller.getQuery();
            p.counponCodes = counponCodes[counponCodes.length - 1];
            url = commonJSCaller.setQuery(url, p);
            commonJSCaller.jumpToWap(url);
        })
    },
    //从房号直签过来，index只会为1
    initCoupon: function (index) {
        if (paramsUrl.counponCodes) {
            var codes = paramsUrl.counponCodes;
            counponCodes[index] = codes;
            codes = codes.split(',');
            var mount = 0, s = [];
            codes.forEach(function (el, i) {
                counponList[index].forEach(function (c) {
                    if (el == c.couponCode) {
                        s.push(c);
                    }
                });
            });
            mount = financeInvoker.convertCouponAmount(s, index);
            $('.has_coupon').eq(index).removeClass('none').addClass('c-red').attr('data-coupon', mount).find('span').html('- ￥' + mount);
            $(".no_coupon").eq(index).addClass("none");
            if ($('.finance-tab').length == 2 && index == 0) return;
            var allP = $('.pay-total').eq(index).data('total');
            $('.pay-total').eq(index).html(commonJSCaller.FloatSub(Number(allP), Number(mount)));
        }
    },
    /**
     * @desc 获取可用优惠
     */
    getCouponList: function (data, index) {
        var subject = data;
        var month = paramsUrl.contractCycle;
        var c = {}, subjectList = [];
        $.each(subject, function (i, o) {
            c[o.subjectInfoId.toString()] = o.costAmount;
            subjectList.push({
                subjectId: o.subjectInfoId,
                count: 1 || o.count,//笔数
                money: o.costAmount
            })
        });

        var para = {
            apartmentId: paramsUrl.apartment_id,
            useChannelCode: "lefull-tenant-app",
            sceneCode: couponSceneCode,
            subjectNumberAndMoneyJsonStr: JSON.stringify(c),
            contractCycle: month
        };

        //临时存储
        var storeForm = JSON.parse(JSON.stringify(para));
        storeForm.subjectList = subjectList
        couponForm[index] = storeForm;

        var options = {
            name: "get_coupon",
            apiList: financeAPI['apiList'],
            serviceName: "marketing",
            param: para,
            datatype: "json",
            calSuc: function (json) {
                var cous = [];
                if (json.data.length > 0) {
                    json.data.forEach(function (el, i) {
                        el.list.forEach(function (l) {
                            cous.push(l);
                        })
                    });
                    $('.has_coupon').eq(index).removeClass('none').find('span').html(cous.length + '张优惠券可用');
                    $(".no_coupon").eq(index).addClass("none");
                    counponList[index] = cous;
                    //房号直签带过来的优惠带在全额支付里
                    financeInvoker.initCoupon(index);
                } else {
                    $('.has_coupon').eq(index).addClass('none');
                    counponList[index] = [];
                    $(".no_coupon").eq(index).removeClass("none");
                }
            },
            calFail: function (json) {
                $(".no_coupon").eq(index).removeClass("none");
                counponList[index] = [];
            }
        };
        LeHttp.send(options)
    },
    //倒计时
    countingDown: function () {
        var now = nowTime;
        var _createTime = parseInt(expirationTime);
        if (_createTime - now >= 0) {
            var seconds = _createTime - now;
            //转化为hh:mm:ss
            var hh, mm, ss;
            mm = parseInt(seconds / 60);
            ss = seconds % 60;
            $("#counter").text((mm < 10 ? ("0" + mm) : mm) + ":" + (ss < 10 ? ("0" + ss) : ss))
            //开始倒计时
            this.setCountingDown($("#counter"), mm, ss);
        } else {
            //失效了
            this.resetStyle($("#counter"));//设置超时样式
        }
    },
    setCountingDown: function (cur, m, s) {
        var timer = timer;
        var self = this;
        if (timer != null) {
            clearInterval(timer);
        }
        timer = setInterval(function () {
            if (s == 0) {
                if (m > 0) {
                    m -= 1;
                    s = 59;
                } else {
                    clearInterval(timer);
                    self.resetStyle(cur);//设置超时样式
                }
            }
            if (s > 0) s--;
            $(cur).text("" + (m < 10 ? ("0" + m) : m) + ":" + (s < 10 ? ("0" + s) : s))
        }, 1000);
    },
    //设置超时样式
    resetStyle: function (elm) {
        elm.parent().text("订单已超时，请重新下单").addClass("timeout");
        $(".ui-btn-green").addClass("disabled");
    },
    convertCouponAmount: function (coupons, index) {
        var suj = {};
        coupons.forEach(function (el, i) {
            if (!suj[el.subjectNumber]) {
                suj[el.subjectNumber] = {
                    amount: 0,
                    name: ''
                };
            }
            ;
            suj[el.subjectNumber].amount = commonJSCaller.FloatAdd(suj[el.subjectNumber].amount, Number(el.discountMoney))
            suj[el.subjectNumber].name = el.subjectName;
        });

        //判断科目费用是否小于优惠券费用，小于则优惠券 == 科目费用
        var packages = JSON.parse(JSON.stringify(fullPackages));;
        if ($('.finance-tab').length == 2 && index == 0) {
            //有分期
            packages = JSON.parse(JSON.stringify(monthsPackages));
        }
        for (var key in suj) {
            packages.forEach(function (el) {
                if (el.subjectInfoId == key && el.costAmount < suj[key].amount) {
                    suj[key].amount = el.costAmount
                }
            });
        }

        var total = 0;
        for (var key in suj) {
            total = commonJSCaller.FloatAdd(total, Number(suj[key].amount))
        }

        return total;
    },
    /**
     * @desc 获取详情
     */
    getDetail: function () {
        var name = "findContractBillForQuarterlyPayment";
        var param = {
            serviceCode: paramsUrl.serviceCode,
            billId: paramsUrl.contractBillId
        };
        var _this = this;
        commonJSCaller.showLoading()
        var options = {
            name: name,
            apiList: financeAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                commonJSCaller.hideLoading(function () {
                    //3.31日 晶晶说以下几个门店隐藏全额支付入口 31,10,43,49,28,57,42,38
                    // var hideAllPayAaprtments = '31,10,43,49,28,57,42,38';
                    // hideAllPayAaprtments = hideAllPayAaprtments.split(',');
                    // if(hideAllPayAaprtments.indexOf(paramsUrl.apartment_id)>-1){
                    //     json.data.hideAllPay = true;
                    // }

                    json.data.statementTime_f = LeUtil.Date.formatToDate(json.data.statementTime, 'yyyy/MM/dd');
                    json.data.billPeriodBeginTime_f = LeUtil.Date.formatToDate(json.data.billPeriodBeginTime, 'yyyy/MM/dd');
                    json.data.billPeriodEndTime_f = LeUtil.Date.formatToDate(json.data.billPeriodEndTime, 'yyyy/MM/dd');
                    contracBillId = json.data.billId;
                    expirationTime = json.data.expiredTime;
                    nowTime = json.data.currentTime;
                    installmentType = json.data.installmentType;
                    couponSceneCode = json.data.billType;
                    contractId = json.data.contractId;
                    monthsPackages = json.data.installmentPaySubject;
                    fullPackages = json.data.fullPaySubject;
                    // json.data.paymentPackageList.forEach(function (el, i) {
                    //     if (typeof el.list == 'object') {
                    //         el.list.forEach(function (l) {
                    //             l.subjectCode = l.subjectInfoId
                    //             l.amount = l.costAmount
                    //         })
                    //     }
                    // if(json.data.couponSupport == 1){
                    //     financeInvoker.getCouponList(el, i);
                    // }
                    // });

                    var dt = {
                        data: json.data
                    };
                    var tmp = template("all-temp", dt);
                    $("#all-pay").html(tmp);
                    //绑定事件
                    _this.bindEvt();
                    setTimeout(function () {
                        $('.clickCoupon').click(function () { });
                        $('.show_detail').click(function(){
                        });
                    }, 0);
                    //倒计时开始
                    var scode = paramsUrl.serviceCode
                    // if ($(".time-bar")[0] && (scode == 'rent' || scode == 'preordain' || scode == 'renew') && json.data.expiredSupport == 1) {
                    //     _this.countingDown();
                    //     $('.time-bar').show();
                    // }

                    //赋值支付参数
                    payUrl.serviceCode = json.data.serviceCode;
                    payUrl.contractBillId = json.data.billId;

                    //渲染不支持优惠券时的样式
                    if (json.data.couponSupport == 1) {
                        $('.has_coupon').removeClass('none');
                        $(".no_coupon").addClass("none");
                        if ($('.finance-tab').length == 2) {
                            //支持分期
                            counponList = [[], []];
                            counponCodes = ['', ''];
                            //分期请求优惠券
                            financeInvoker.getCouponList(json.data.installmentPaySubject, 0);
                            //全额请求优惠券
                            financeInvoker.getCouponList(json.data.fullPaySubject, 1);
                        } else {
                            //不支持分期
                            //全额请求优惠券
                            counponList = [[]];
                            counponCodes = [''];
                            financeInvoker.getCouponList(json.data.fullPaySubject, 0);
                        }

                    }
                    //tab和按钮切换
                    $('.ui-btn-green').eq(0).removeClass('none');

                    $('.finance-tab').eq(0).addClass('on').find('.iconfont').removeClass('c-grey icon-weixuanzhong').addClass('icon-xuanzhong c-gren');;
                })
            },
            calFail: function (error) {
                commonJSCaller.hideLoading(function () {
                    alert(error.msg || '获取账单失败，请联系管家！')
                });
            }
        }
        LeHttp.send(options)
    }
};

function JsBridgeFinished() {
    financeInvoker.init();
}
