var contractInvoker = {
    /**
     *
     * @param {*}
     */
    init:function() {
        this.bindEvt();
        this.getList();
    },
    bindEvt:function() {
        //展示金额详细
        $(document).on('click', '.show_detail', function () {
            var cur = $(this);
            $(this).find('.iconfont').toggleClass('icon-xiangshangjiantou').toggleClass('icon-xiangxiajiantou');
            if (cur.hasClass("active")) {
                cur.removeClass("active");
                cur.next().slideUp(200);
            } else {
                cur.addClass("active");
                cur.next().slideDown(200);
            }
        });
    },
    /** 跳转逻辑
     *季付：1、可分期-跳转checkin_finance.html 2、不可分期-跳转bill_pay.html 3、部分支付-跳转bill_pay.html
     *已分期：1、跳转bill_pay.html
     */
    /**
     * @desc 获取列表
     */
    getList:function() {
        var name = "queryPaidContractRecordByTenantId";
        var param = {
            // serviceCode:commonJSCaller.getQuery().serviceCode,
            contractId:commonJSCaller.getQuery().contractId
        };
        var _this = this;
        commonJSCaller.showLoading();
        var options = {
            name: name,
            apiList: contractAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                commonJSCaller.hideLoading(function(){
                    var nar = [];

                    json.data.paidContractBillList.forEach(function(el,i){
                        el.statementTimeF = LeUtil.Date.formatToDate(el.statementTime,'yyyy-MM-dd').replace(/-/g,"/");
                        el.billPeriodBeginTimeF = LeUtil.Date.formatToDate(el.statementBeginTime,'yyyy-MM-dd').replace(/-/g,"/");
                        el.billPeriodEndTimeF = LeUtil.Date.formatToDate(el.statementEndTime,'yyyy-MM-dd').replace(/-/g,"/");
                        el.laterTimeF = LeUtil.Date.DateAdd('d',1,new Date(el.billPeriodEndTimeF)).substring(5,10);
                        el.month=Math.round(contractInvoker.datedifference(el.billPeriodBeginTimeF,el.billPeriodEndTimeF)/30);
                        el.isZf = el.billType == 2 ? 1 : 0;
                        nar.push(el);
                    });
                    console.log(nar);
                    var dt = {
                        data:nar
                    }
                    var tmp = template("temp", dt);
                    $("#contracts").append(tmp);
                    $('.show_detail').click(function(){
                    })
                });
            },
            calFail: function (err) {
                commonJSCaller.hideLoading(function(){
                    alert(err.msg || '获取账单失败，请稍后再试')
                });
            }
        }
        LeHttp.send(options)
    },
    datedifference:function(sDate1, sDate2) {    //sDate1和sDate2是2006-12-18格式
        var dateSpan,
            tempDate,
            iDays;
        sDate1 = Date.parse(sDate1);
        sDate2 = Date.parse(sDate2);
        dateSpan = sDate2 - sDate1;
        dateSpan = Math.abs(dateSpan);
        iDays = Math.floor(dateSpan / (24 * 3600 * 1000));
        return iDays
    }
};

function JsBridgeFinished(){
    contractInvoker.init();
}