var contractInvoker = {
    /**
     *
     * @param {*}
     */
    init:function() {
        this.bindEvt();
        this.getList();
    },
    bindEvt:function() {
        //展示金额详细
        $(document).on('click','.show_detail',function(){
            var cur = $(this);
            $(this).find('.iconfont').toggleClass('icon-xiangshangjiantou').toggleClass('icon-xiangxiajiantou');
            if (cur.hasClass("active")) {
                cur.removeClass("active");
                cur.next().slideUp(200);
            } else {
                cur.addClass("active");
                cur.next().slideDown(200);
            }
        });
        //点击支付
        $(document).on('click','.submit',function(){
            //paystatus 1:部分支付; 2:未支付; 3:已经结清',
            var cur = $(this),paystatus = cur.data('paystatus'),isMonth = cur.data('month'),canMonth = cur.data('canmonth'),
                aparmentid = cur.data('aparmentid'), code = cur.data('code'),contractCycle=cur.data('cycle'),contractBillId = cur.data('billid'),isZf = cur.data('iszf')
            if((canMonth == 1 && isMonth == 2 && paystatus == 2) || isZf == 1){
                var p = {
                    apartment_id: aparmentid,
                    serviceCode: code,
                    contractId: commonJSCaller.getQuery().contractId,
                    contractBillId: contractBillId,
                    counponCodes: '',
                    contractCycle: contractCycle,
                    fromlist:1
                };
                var url = commonJSCaller.setQuery("/checkin_finance.html", p);
                commonJSCaller.jumpToWap(url);
            }else{
                var p = {
                    apartment_id:aparmentid,
                    contractBillId : contractBillId,
                    serviceCode: code,
                    contractCycle: contractCycle,
                    contractId:commonJSCaller.getQuery().contractId,
                    fromlist:1
                };
                var url = commonJSCaller.setQuery("/bill_pay.html", p);
                commonJSCaller.jumpToWap(url);
            }
        })
    },
    /** 跳转逻辑
     * 杂费跳转checkin_finance.html
     *季付：1、可分期（季付&&未支付&&可分期）-跳转checkin_finance.html 2、不可分期（季付）-跳转bill_pay.html 3、部分支付-跳转bill_pay.html
     *已分期：1、跳转bill_pay.html
     */
    /**
     * @desc 获取列表
     */
    getList:function() {
        var name = "findReceivableBill";
        var param = {
            serviceCode:  commonJSCaller.getQuery().serviceCode,
            contractId:  commonJSCaller.getQuery().contractId
        };
        commonJSCaller.showLoading();
        var _this = this;
        var options = {
            name: name,
            apiList: contractAPI["apiList"],
            serviceName: "micro",
            param: param,
            calSuc: function (json) {
                commonJSCaller.hideLoading(function(){
                    var nar = [];
                    var isSu = json.data.isSurrender == 1 ? 1 : 0;
                    //isSurrender 0：没有退租，1：退租
                    json.data.billList.forEach(function(el,i){
                        if(el.payStatus !=3){
                            el.statementTimeF = LeUtil.Date.formatToDate(el.statementTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.billPeriodBeginTimeF = LeUtil.Date.formatToDate(el.billPeriodBeginTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.billPeriodEndTimeF = LeUtil.Date.formatToDate(el.billPeriodEndTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.laterTimeF = LeUtil.Date.DateAdd('d',1,new Date(el.billPeriodEndTimeF)).substring(5,10);
                            el.month=Math.round(contractInvoker.datedifference(el.billPeriodBeginTimeF,el.billPeriodEndTimeF)/30);
                            el.isZf = 0;
                            el.noPayment = commonJSCaller.FloatSub(el.billAmount,el.payAmount)
                            el.isSu = isSu;
                            nar.push(el);
                        }
                    });
                    json.data.incidentalList.forEach(function(el,i){
                        if(el.payStatus !=3){
                            el.statementTimeF = LeUtil.Date.formatToDate(el.statementTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.billPeriodBeginTimeF = LeUtil.Date.formatToDate(el.billPeriodBeginTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.billPeriodEndTimeF = LeUtil.Date.formatToDate(el.billPeriodEndTime,'yyyy-MM-dd').replace(/-/g,"/");
                            el.laterTimeF = LeUtil.Date.DateAdd('d',1,new Date(el.billPeriodEndTimeF)).substring(5,10);
                            el.month=Math.round(contractInvoker.datedifference(el.billPeriodBeginTimeF,el.billPeriodEndTimeF)/30);
                            el.isZf = 1;
                            el.isSu = isSu;
                            el.noPayment = commonJSCaller.FloatSub(el.billAmount,el.payAmount);
                            el.subjectList.forEach(function(o){
                                o.costAmount = o.subjectAmount;
                            })
                            nar.push(el);
                        }
                    });

                    var dt = {
                        data:nar,
                        hideBtn:commonJSCaller.getQuery().isSurrender==1    //0 现有租约 1 历史租约
                    };

                    var tmp = template("temp", dt);
                    $("#contracts").append(tmp);
                    $('.show_detail').click(function(){
                    })
                });
            },
            calFail: function (err) {
                commonJSCaller.hideLoading(function(){
                    alert(err.msg || '获取账单失败，请稍后再试')
                })
            }
        }
        LeHttp.send(options)
    },
    datedifference:function(sDate1, sDate2) {    //sDate1和sDate2是2006-12-18格式
        var dateSpan,
            tempDate,
            iDays;
        sDate1 = Date.parse(sDate1);
        sDate2 = Date.parse(sDate2);
        dateSpan = sDate2 - sDate1;
        dateSpan = Math.abs(dateSpan);
        iDays = Math.floor(dateSpan / (24 * 3600 * 1000));
        return iDays
    }
};

function JsBridgeFinished(){
    contractInvoker.init();
}