// import { promise } from "_thunks@4.9.5@thunks";

/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-02-26 11:23:26
 */
//提交参数
var modalForm = {
    apartment_id: "",
    city_id:"",
}, noTemplate = false;
var communityList = false,sampleList = false;
/**
 * @desc 页面获取推荐列表
 */
function getFollowHouseList() {
    // commonJSCaller.showLoading();
        var options = {
            name: "getFollowHouseList",
            apiList: myAttentionAPI['apiList'],
            serviceName: "client2",
            calSuc: function (res) {
                // commonJSCaller.hideLoading();
                if(res.status == 1){
                    apartment_list = res.data.apartment_list || [];
                    sample_room_list = res.data.sample_room_list || []
                    if(apartment_list.length == 0 && sample_room_list.length == 0) return showNothing();
                    if(apartment_list.length > 0){
                        apartment_list.forEach(item => {
                            item.img = qiniuURL + item.cover_img;
                            item.apartment_name = item.apartment_name == ''?'' :item.apartment_name + '社区'
                        })
                        let json = {
                            data:apartment_list
                        }
                        var temp = template("community-temp", json);
                        $('#communityList').html(temp);
                        $('.noCommunityList').addClass('disn');
                    }else{
                        $('.noCommunityList').removeClass('disn');
                        $('#communityList').html('');
                    }
                    if(sample_room_list.length > 0) {
                        sample_room_list.forEach(item => {
                            item.img = qiniuURL + item.cover_img;
                         })
                         let json = {
                             data:sample_room_list
                         }
                         var temp = template("sample-temp", json);
                         sampleList = true;
                         $('#sampleList').html(temp);
                         $('.noSample').addClass('disn');
                    }else{
                        $('.noSample').removeClass('disn');
                        $('#sampleList').html('');
                    }
                }else{
                    showNothing();
                }
            },
            calFail: function (err) {
                // commonJSCaller.hideLoading();
                showNothing();
            }
        }
        LeHttp.send(options)
    
}

// 节流函数
function eventHandler(func,wait) {
    var timeout;
    return function () {
        var context = this;
        var args = arguments;

        if (timeout) clearTimeout(timeout);

        var callNow = !timeout;
        timeout = setTimeout(function (){
            timeout = null;
        }, wait)

        if (callNow) func.apply(context, args)
    }
}

function showNothing(){
        $('.nothing').removeClass('disn');
}
// 处理点击等时间
function handler() {
    $('#communityList').on('click','.communityToDetail',eventHandler(function(){
        var apartment_id = $(this).data('id');
        //跳转只社区详情
    commonJSCaller.jumpClientApp('ApartmentDetail', {apartmentId:apartment_id}, function (res) { });
    },800))
    $('#sampleList').on('click','.sampleToDetail',eventHandler(function(){
        var sample_id = $(this).data('id');
        //跳转至户型社区详情
    commonJSCaller.jumpClientApp('RoomDetail', {sampleRoomRelationshipId:sample_id}, function (res) { });
    },800))
    $('.m-button').click(eventHandler(function(){
        //跳转只社区详情
        commonJSCaller.jumpClientApp('RoomList', {}, function (res) { });
    },800))
}
/**
 * @desc 页面地址初始化
 */
function initPage() {
    var param = commonJSCaller.getQuery();

    if (param.period) {
        param.period = Number(param.period);
    }
    //页面传递参数赋值
    modalForm.apartment_id = param.apartment_id;
    modalForm.city_id = param.city_id;


    // modalForm.apartmentName = param.title.split("-")[0];//合并了只取门店名称

    console.log(modalForm)

    //加载列表
    getFollowHouseList();
}

function JsBridgeFinished() {
    initPage();
    handler();
    // bindEvt();
    // commonJSCaller.getOnlineCardApartment();
    // ruleInvoker.init(0, function (j) {
    //     if (typeof j == 'object') {
    //         //协议加载失败或者没有协议
    //         noTemplate = true
    //     }
    // });
}
