var financeInvoker = {
    /**
     *
     * @param {*}
     */
    init:function() {
        this.bindEvt();
        $('#orderNum').html(commonJSCaller.getQuery().contractBillId);
        $('#amount').html('¥' + commonJSCaller.getQuery().amount);
        $('#textPay').html('¥' + commonJSCaller.getQuery().payMoney);
    },
    bindEvt:function() {
        $('#splitPay').click(function () {
            if($(this).hasClass('c-999'))return;
            $('#inputPay').removeClass('opa0').removeAttr('disabled').focus();
            $(this).addClass('c-999').removeClass('c-green');
        });
        //支付
        $('#submit').click(function () {
            financeInvoker.pay();
        });
        $('#inputPay').on('blur',function(){
            setTimeout(function(){
                window.scrollTo(0,0);
            },50)
        })
    },
    /**
     * @desc 立即支付
     */
    pay:function() {
        var payFunc = function (money) {
            //调起支付
            var param = commonJSCaller.getQuery();
            param.payAmount = money || commonJSCaller.getQuery().payMoney;
            payInvoker.payContractBill(param, function (json) {
                if (json.data.status == 1) {
                    commonJSCaller.jumpClientApp('Cashier', {payURL: json.data.url,clearRouteList:1},function(){
                        commonJSCaller.paySuccessRoute({contract_id: commonJSCaller.getQuery().contractId},commonJSCaller.getQuery().originServiceCode || commonJSCaller.getQuery().serviceCode,commonJSCaller.getQuery().fromlist,commonJSCaller.getQuery().fromh5);
                    });
                } else {
                    alert(json.data.message|| '账单支付失败');
                }
            });
        };
        if ($('#inputPay').hasClass('opa0')) {
            //支付
            payFunc();
        } else {
            var money = LeUtil.Reg.trimStr($('#inputPay').val());
            $('#inputPay').val(money);
            if (money == '') {
                alert('请输入剩余应付金额');
                return false;
            }
            money = Number(money);
            if (isNaN(money)) {
                alert('请输入数字');
                return false;
            }
            $('#inputPay').val(money);
            if (money > Number(commonJSCaller.getQuery().payMoney)) {
                alert('支付金额不能大于剩余应付金额');
                return false;
            }
            //支付
            payFunc(money);
        }
    }
};

function JsBridgeFinished(){
    financeInvoker.init();
}