/*
 * @Author: Jack 
 * @Date: 2019-01-09 09:17:00 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-01-14 09:15:26
 */
var ruleAPI = {
    apiList: [
        {
            "name": "get_surrender_rule",
            "method": "get",
            "desc": "获取退租协议", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/CustomTemplate/lisaDismissAgreement" //请求路径
        },
        {
            "name": "get_contract",
            "method": "get",
            "desc": "获取租赁合同模板", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/CustomTemplate/checkInTemplate" //请求路径
        },
        {
            "name": "get_book_rule",
            "method": "get",
            "desc": "获取预定协议", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/CustomTemplate/preordainTemplate" //请求路径
        },
        {
            "name": "get_auth",
            "method": "get",
            "desc": "租客公约", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/CustomTemplate/tenantAuthTemplate" //请求路径
        },
        {
            "name": "get_month_rule",
            "method": "get",
            "desc": "分期协议", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/CustomTemplate/iousTemplate" //请求路径
        },
        {
            "name": "protocol",
            "method": "get",
            "desc": "乐乎会员卡协议", //描述
            "api": "lisa", //服务名称 全部统一为lisa
            "path": "/Account/protocol" //请求路径
        },
        {
            "name": "get_tenant_auth",
            "method": "get",
            "desc": "判断是否签名", //描述
            "api": "client2", //服务名称 全部统一为lisa
            "path": "Tenant/getTenantAuth/version/2" //请求路径
        },
    ]
}
