/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-01-17 19:11:04
 */
//定义服务
var serviceName = "tenancy";

var modalForm = {};//页面提交数据集合


//提交退租申请
function bindEvt() {
    $("#submit").click(function () {
        var cur = $(this), text = cur.text();
        btnJSCaller.setBtnLoading(cur);
        console.log(modalForm);
        var name = "confirm_tenancyOrder";
        var options = {
            name: name,
            apiList: surrenderAPI['apiList'],
            serviceName: serviceName,
            datatype: "json",
            param: JSON.stringify(modalForm),
            //成功执行
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                console.log(json);
            },
            //错误执行
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    });
}

/**
 * @desc 获取退租详情
 */
function getTenantyOrder() {
    var name = "get_detail";
    var contractId = commonJSCaller.getQuery().contractId;
    var options = {
        name: name,
        apiList: surrenderAPI['apiList'],
        serviceName: serviceName,
        param: {
            contractId: contractId
        },
        calSuc: function (json) {
            setPageData(json.data);
            modalForm = json.data;
            modalForm.contractId = contractId;
        },
        calFail: function (json) {
            console.log(json)
            //失败处理
            alert(json.msg)
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} data
 * @desc 费用科目模板生成
 */
function setCostData(data) {
    var json = {
        data: data
    }
    var temp = template("subject-temp", json);
    $("#subject-list").html(temp);
}

/**
 *
 * @param {*} json
 * @Desc 页面数据赋值
 */
function setPageData(json) {
    //门店信息
    $("#apt-name").text(json.apartment);
    $("#apt-room .iconfont").after(json.roomNumber);
    $("#apt-price .iconfont").after(json.rental + "/月");
    $("#apt-area .iconfont").after(json.area + "㎡");
    $("#checin_date").text(json.beginTime.replace(/\//g, "-"));
    $("#surrender_date").text(json.revokeTime.replace(/\//g, "-"));
    $("#applyName").text(json.applyName);
    if (modalForm.shouldPay == 1) {
        $("#pay").removeClass("none");//支付
    } else {
        $("#submit").removeClass("none");//退款
    }
    setCostData(json.subjectInfos);
}

/**
 * 页面信息初始化
 */
function initPage() {
    getTenantyOrder();
    bindEvt();
}

function JsBridgeFinished() {
    initPage();
}

