/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-01-22 15:34:22
 */

//定义服务

/**
 * @desc 获取退租详情
 */
function getTenantyOrder() {
    var name = "get_detail";
    var options = {
        name: name,
        apiList: surrenderAPI['apiList'],
        serviceName: "tenancy",
        param: {
            contractId: commonJSCaller.getQuery().contractId
        },
        calSuc: function (json) {
            setPageData(json.data);
        },
        calFail: function (json) {
            alert(json.msg)
            //失败处理
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} data
 * @desc 费用科目模板生成
 */
function genCostTemp(data) {
    var json = {
        data: data
    }
    var temp = template("subject-temp", json);
    $("#subject-list").html(temp);
}

/**
 *
 * @param {*} json
 * @Desc 页面数据赋值
 */
function setPageData(json) {
    //门店信息
    $("#apt-name").text(json.apartment);
    $("#apt-room .iconfont").after(json.roomNumber);
    $("#apt-price .iconfont").after(json.rental + "/月");
    $("#apt-area .iconfont").after(json.area + "㎡");
    $("#checin_date").text(json.beginTime.replace(/\//g, "-"));
    $("#surrender_date").text(json.revokeTime.replace(/\//g, "-"));
    $("#applyName").text(json.applyName);
    $("#fee-total").text("¥" + json.total);
    var dt = {
        status: json.revokeStatus
    }
    var statusTem = template("status-temp", dt);
    $("#wgt-t").append(statusTem);
    genCostTemp(json.subjectInfos);
}

/**
 * 页面信息初始化
 */
function initPage() {
    getTenantyOrder();
}

function JsBridgeFinished() {
    initPage();
}
